<?php
/*
 *  Plugin Name: MegaCalendar
 *  Description: A Modern Calendar and Event List for communities and organizations
 *  Author: Megabase
 *  Version: 0.2.1
 *  Author URI: 
 *
 *	------------------------------------------------------------------------
 *	Copyright 2020 Megabase, Inc.
 *
 *	This plugin is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 3 of the License, or
 *	(at your option) any later version.
 *
 *	This plugin is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this plugin.  If not, see http://www.gnu.org/licenses.
*/

/** Define path identifiers **/
if (!defined('MEGACAL_PLUGIN'))
    define('MEGACAL_PLUGIN', __FILE__);

if (!defined('MEGACAL_PLUGIN_DIR'))
    define('MEGACAL_PLUGIN_DIR', untrailingslashit( dirname( MEGACAL_PLUGIN ) ) );

if( !defined('MEGACAL_API_DIR') )
    define( 'MEGACAL_API_DIR', untrailingslashit( MEGACAL_PLUGIN_DIR . '/includes/megacal-api-client' ) );

if( !defined( 'MEGACAL_SETTINGS_SLUG' ) )
    define( 'MEGACAL_SETTINGS_SLUG', 'megacal-integration' );

if( !defined( 'MEGACAL_UPGRADE_SLUG' ) )
    define( 'MEGACAL_UPGRADE_SLUG', 'megacal-upgrade' );

if( !defined( 'MEGACAL_MANAGE_SLUG' ) )
    define( 'MEGACAL_MANAGE_SLUG', 'megacal-manage' );

if( !defined( 'MEGACAL_EVENT_DETAIL_URL' ) )
    define( 'MEGACAL_EVENT_DETAIL_URL', 'events/' );

if( !defined( 'MEGACAL_SETTINGS_URL' ) ) 
    define( 'MEGACAL_SETTINGS_URL', admin_url( 'admin.php?page=' . MEGACAL_SETTINGS_SLUG ) );

if( !defined( 'MEGACAL_UPGRADE_URL' ) ) 
    define( 'MEGACAL_UPGRADE_URL', admin_url( 'admin.php?page=' . MEGACAL_UPGRADE_SLUG ) );

if( !defined( 'MEGACAL_ADMIN_CALENDAR_CACHE_KEY' ) )
    define( 'MEGACAL_ADMIN_CALENDAR_CACHE_KEY', 'megacal_admin_calendar_events' );

if( !defined( 'MEGACAL_PAST_LIST_CACHE_KEY' ) )
    define( 'MEGACAL_PAST_LIST_CACHE_KEY', 'megacal_past_list_events' );

if( !defined( 'MEGACAL_PUBLIC_CALENDAR_CACHE_KEY' ) )
    define( 'MEGACAL_PUBLIC_CALENDAR_CACHE_KEY', 'megacal_public_calendar_events' );

if( !defined( 'MEGACAL_UPCOMING_LIST_CACHE_KEY' ) ) 
    define( 'MEGACAL_UPCOMING_LIST_CACHE_KEY', 'megacal_upcoming_list_events' );

if( !defined( 'MEGACAL_CACHED_VENUES_CACHE_KEY' ) )
    define( 'MEGACAL_CACHED_VENUES_CACHE_KEY', 'megacal_cached_venues' );

if( !defined( 'MEGACAL_CACHED_CATEGORIES_CACHE_KEY' ) )
    define( 'MEGACAL_CACHED_CATEGORIES_CACHE_KEY', 'megacal_cached_categories' );

if( !defined( 'MEGACAL_CACHED_MY_CATEGORIES_CACHE_KEY' ) )
    define( 'MEGACAL_CACHED_MY_CATEGORIES_CACHE_KEY', 'megacal_cached_my_categories' );

if( !defined( 'MEGACAL_PING_RESPONSE_CACHE_KEY' ) )
    define( 'MEGACAL_PING_RESPONSE_CACHE_KEY', 'megacal_ping_response' );

if( !defined( 'MEGACAL_CACHED_EVENT_OWNERS_CACHE_KEY' ) )
    define( 'MEGACAL_CACHED_EVENT_OWNERS_CACHE_KEY', 'megacal_cached_event_owners' );

if( !defined( 'MEGACAL_CACHED_HOVER_CARD_CACHE_KEY' ) )
    define( 'MEGACAL_CACHED_HOVER_CARD_CACHE_KEY', 'megacal_cached_hover_cards' );

if( !defined( 'MEGACAL_EVENT_CACHE_EXPIRE_TIME' ) )
    define( 'MEGACAL_EVENT_CACHE_EXPIRE_TIME', HOUR_IN_SECONDS );
    
if( !defined( 'MEGACAL_LEGACY_ICS_PATH' ) )
    define( 'MEGACAL_LEGACY_ICS_PATH', 'plugin/megabase-calendar/generate-ics/' );

if( !defined( 'MEGACAL_ICS_PATH' ) )
    define( 'MEGACAL_ICS_PATH', 'plugin/megabase-calendar/public/' );

// Expose the plugin to specific users
// publish_posts = Authors and above
if( !defined( 'MEGACAL_PLUGIN_VISIBILITY_CAP' ) )
    define( 'MEGACAL_PLUGIN_VISIBILITY_CAP', 'publish_posts' );

// Expose the authentication tokens to specific users
if( !defined( 'MEGACAL_TOKEN_VISIBILITY_CAP' ) )
    define( 'MEGACAL_TOKEN_VISIBILITY_CAP', 'manage_options' );

if( !defined( 'MEGACAL_RECURRENCE_TYPE_FREQ_FMT' ) )
    define( 'MEGACAL_RECURRENCE_TYPE_FREQ_FMT', 'frequency' );

if( !defined( 'MEGACAL_RECURRENCE_TYPE_SINGULAR_FMT' ) )
    define( 'MEGACAL_RECURRENCE_TYPE_SINGULAR_FMT', 'singular' );

if( !defined( 'MEGACAL_RECURRENCE_TYPE_PLURAL_FMT' ) )
    define( 'MEGACAL_RECURRENCE_TYPE_PLURAL_FMT', 'plural' );

if( !defined( 'MEGACAL_DEFAULT_CATEGORY_NAME' ) )
    define( 'MEGACAL_DEFAULT_CATEGORY_NAME', 'Default' );

if( !defined( 'MEGACAL_EVENT_LIST_RESULTS_PER_PAGE' ) )
    define( 'MEGACAL_EVENT_LIST_RESULTS_PER_PAGE', 15 );

if( !defined( 'MEGACAL_STRIPE_PORTAL_URL' ) )
    define( 'MEGACAL_STRIPE_PORTAL_URL', 'https://billing.stripe.com/login/5kAeVG5M43gsf6g9AA' );

require_once( MEGACAL_PLUGIN_DIR . '/bootstrap.php' );

use Kigkonsult\Icalcreator\Vcalendar;
use MegaCal\Client\MegaCalAPI;
use MegaCal\Client\ApiException;
use MegaCal\Client\CheckHandleResponse;
use MegaCal\Client\Event;
use MegaCal\Client\EventDeleteResponse;
use MegaCal\Client\EventDetailResponse;
use MegaCal\Client\EventFilterResponse;
use MegaCal\Client\EventListResponse;
use MegaCal\Client\EventProcessingDetail;
use MegaCal\Client\EventProcessingResponse;
use MegaCal\Client\EventProcessingStage;
use MegaCal\Client\EventRecurrenceDetail;
use MegaCal\Client\EventRecurrenceResponse;
use MegaCal\Client\EventUpsertBodyResponse;
use MegaCal\Client\EventUpsertResponse;
use MegaCal\Client\PingResponse;
use MegaCal\Client\PutApprovalResponse;
use MegaCal\Client\RegisterResponse;
use MegaCal\Client\UserRequest;

if (!class_exists('MegabaseCalendar')):

class MegabaseCalendar {

    private static $instance;
    private static $shortcode_instances = 0;

    private static $access_token;
    private static $refresh_token;
    private $api;

    /** The Constructor **/
    function __construct() {

        if( null !== self::$instance ) {
            return self::$instance;
        } else {
            self::$instance = $this;
        }

        $this->api = MegaCalAPI::get_instance();

        $dotenv = Dotenv\Dotenv::createImmutable( MEGACAL_PLUGIN_DIR );
        $dotenv->safeLoad();

        register_activation_hook( MEGACAL_PLUGIN, array( $this, 'megacal_activation' ) );
        register_deactivation_hook( MEGACAL_PLUGIN, array( $this, 'megacal_deactivation' ) );

        register_setting(
            MEGACAL_SETTINGS_SLUG,
            'megacal_options',
            array($this, 'megacal_validate_input')
        );

        register_setting(
            MEGACAL_SETTINGS_SLUG,
            'megacal_hidden_options'
        );

        register_setting(
            'megacal_execution_id_store',
            'megacal_execution_id_store'
        );

        register_setting(
            'megacal_processing_errors',
            'megacal_processing_errors'
        );

        $settings = ( !empty( self::megacal_get_settings() ) ) ? self::megacal_get_settings() : array();
        $hidden_settings = self::megacal_get_settings( 'megacal_hidden_options' );
        $processing_errors = self::megacal_get_settings( 'megacal_processing_errors' );

        // Action hooks
        add_action( 'admin_menu', array($this, 'admin_menu') );
        add_action( 'admin_init', array($this, 'megacal_admin_init') );
        add_action( 'admin_bar_menu', array( $this, 'megacal_register_admin_bar_menu' ), 99 );
        add_action( 'admin_post_megacal_flush_event_cache', array( $this, 'megacal_admin_post_flush_event_cache' ) );
        add_action( 'admin_enqueue_scripts', array($this, 'megacal_enqueue_admin_scripts') );
        add_action( 'update_option_megacal_options', array( $this, 'megacal_update_settings' ), 10, 2 );
        add_action( 'wp_enqueue_scripts', array($this, 'megacal_enqueue_scripts') );
        add_action( 'after_setup_theme', array( $this, 'megacal_register_custom_schedules' ), 10, 0 );
        add_action( 'wp', array( $this, 'megacal_register_cron_events' ), 10, 0 );
        add_action( 'megacal_check_event_processing_cron', array( $this, 'megacal_check_event_processing' ), 10, 0 );
        add_action( 'megacal_clear_debug_log_cron', array( $this, 'megacal_clear_debug_log' ), 10, 0 );
        
        // Register AJAX actions
        add_action( 'wp_ajax_megacal_check_handle', array( $this, 'megacal_ajax_check_handle' ) );
        add_action( 'wp_ajax_megacal_register', array( $this, 'megacal_ajax_register' ) );
        add_action( 'wp_ajax_megacal_save_event', array( $this, 'megacal_ajax_save_event' ) );
        add_action( 'wp_ajax_megacal_get_event_upsert', array( $this, 'megacal_ajax_get_event_upsert' ) );
        add_action( 'wp_ajax_megacal_get_event_recurrence', array( $this, 'megacal_ajax_get_event_recurrence' ) );
        add_action( 'wp_ajax_megacal_set_event_approval', array( $this, 'megacal_ajax_set_event_approval' ) );
        add_action( 'wp_ajax_megacal_delete_event', array( $this, 'megacal_ajax_delete_event' ) );
        add_action( 'wp_ajax_megacal_fetch_calendar_events', array( $this, 'megacal_ajax_fetch_admin_calendar_events' ) ) ; 
        add_action( 'wp_ajax_megacal_fetch_public_calendar_events', array( $this, 'megacal_ajax_fetch_public_calendar_events' ) );
        add_action( 'wp_ajax_nopriv_megacal_fetch_public_calendar_events', array( $this, 'megacal_ajax_fetch_public_calendar_events' ) );
        add_action( 'wp_ajax_megacal_load_events_list', array( $this, 'megacal_ajax_fetch_list_events' ) );
        add_action( 'wp_ajax_nopriv_megacal_load_events_list', array( $this, 'megacal_ajax_fetch_list_events' ) );
        add_action( 'wp_ajax_megacal_load_event_popup', array( $this, 'megacal_ajax_load_event_popup' ) ); 
        add_action( 'wp_ajax_nopriv_megacal_load_event_popup', array( $this, 'megacal_ajax_load_event_popup' ) ) ; 
        add_action( 'wp_ajax_load_shortcode_options', array( $this, 'megacal_load_shortcode_options' ) );
        add_action( 'wp_ajax_megacal_get_approval_list', array( $this, 'megacal_get_approval_list' ) );

        // Filter hooks
        add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), array( $this, 'megacal_action_links' ) );

        if ( !empty( $settings['megacal_access_token'] ) ) {
            self::$access_token = !empty($settings['megacal_access_token']) ? $settings['megacal_access_token'] : '';
            self::$refresh_token = !empty($settings['megacal_refresh_token']) ? $settings['megacal_refresh_token'] : '';

            // Update handle if empty
            if( empty( $hidden_settings['handle'] ) || empty( $hidden_settings['user_id'] ) ) {

                $ping = $this->megacal_ping_user_account();

                if( false !== $ping ) {

                    $hidden_settings['handle'] = $ping->get_handle();
                    $hidden_settings['user_id'] = $ping->get_user_id();
                    update_option( 'megacal_hidden_options', $hidden_settings );

                }

            }

        }

        if( empty( $settings['megacal_events_url'] ) ) {

            $settings['megacal_events_url'] = MEGACAL_EVENT_DETAIL_URL;
            update_option( 'megacal_options', $settings );

        }

        if( empty( $settings['megacal_event_url_label'] ) ) {
            
            $settings['megacal_event_url_label'] = 'Tickets';
            update_option( 'megacal_options', $settings );

        }

        $this->megacal_register_ics_generator();
        $this->megacal_register_detail_page();

    }

    public function megacal_activation() {
        
        register_setting(
            MEGACAL_SETTINGS_SLUG,
            'megacal_options',
            array( $this, 'megacal_validate_input' )
        );

        $settings = self::megacal_get_settings();

        if( empty( $settings['megacal_default_style'] ) ) {
            $settings['megacal_default_style'] = 'full';
        }

        if( !isset( $settings['megacal_no_event_msg'] ) ) {
            $settings['megacal_no_event_msg'] = 'No events listed at the moment&hellip;';
        }

        if( empty( $settings['megacal_eod_cutoff'] ) ) {
            $settings['megacal_eod_cutoff'] = '12:00 AM';
        }

        if( empty( $settings['megacal_events_url'] ) ) {
            $settings['megacal_events_url'] = MEGACAL_EVENT_DETAIL_URL;
        }

        if( empty( $settings['megacal_event_url_label'] ) ) {
            $settings['megacal_event_url_label'] = 'Tickets';
        }

        update_option( 'megacal_options', $settings );

        $this->megacal_register_ics_generator();
        $this->megacal_register_detail_page();
        flush_rewrite_rules();

    }

    public function megacal_deactivation() {

        // delete hidden settings
        delete_option( 'megacal_hidden_options' );

        // flush transients
        delete_transient( MEGACAL_PING_RESPONSE_CACHE_KEY );
        delete_transient( MEGACAL_CACHED_VENUES_CACHE_KEY );
        delete_transient( MEGACAL_CACHED_CATEGORIES_CACHE_KEY );
        delete_transient( MEGACAL_CACHED_MY_CATEGORIES_CACHE_KEY );
        delete_transient( MEGACAL_CACHED_EVENT_OWNERS_CACHE_KEY );
        $this->megacal_flush_upsert_cache();
        $this->megacal_flush_event_cache();

        flush_rewrite_rules();

    }

    private function megacal_register_ics_generator() {

        add_filter( 'generate_rewrite_rules', function ( $wp_rewrite ){
        
            $wp_rewrite->rules = array_merge(
                [
                    trailingslashit( MEGACAL_ICS_PATH ) . '?$' => 'index.php?generate_ics=1',
                    trailingslashit( MEGACAL_LEGACY_ICS_PATH ) . '?$' => 'index.php?generate_ics=1',
                ],
                $wp_rewrite->rules
            );
        
        } );
        
        add_filter( 'query_vars', function( $query_vars ){
        
            $query_vars[] = 'generate_ics';
            return $query_vars;
        
        } );
        
        add_action( 'template_redirect', function(){
        
            $generate_ics = intval( get_query_var( 'generate_ics' ) );

            if ( $generate_ics ) {
                $this->megacal_generate_ics();
                die;
            }
        
        } );

    }

    private function megacal_register_detail_page() {

        add_filter( 'generate_rewrite_rules', function ( $wp_rewrite ){

            $settings = self::megacal_get_settings();
        
            $event_url = !empty( $settings['megacal_events_url'] ) 
                        ? trim( $settings['megacal_events_url'], '/' ) 
                        : trim( MEGACAL_EVENT_DETAIL_URL, '/' );

            $wp_rewrite->rules = array_merge(
                [trailingslashit( $event_url ) . '([0-9]+)/?$' => 'index.php?event_detail=1&event_id=$matches[1]'],
                $wp_rewrite->rules
            );

        } );
        
        add_filter( 'query_vars', function( $query_vars ) {
        
            if( get_transient( 'megacal_do_rewrite_flush' ) ) {
                flush_rewrite_rules();
                delete_transient( 'megacal_do_rewrite_flush' );
            }

            $query_vars[] = 'event_detail';
            $query_vars[] = 'event_id';
            return $query_vars;
        
        } );
        
        add_action( 'template_redirect', function(){
        
            $event_detail = boolval( get_query_var( 'event_detail' ) );
            $event_id = intval( get_query_var( 'event_id' ) );

            if( $event_detail && $event_id ) {
                $this->megacal_load_event_detail( $event_id );
                die;
            }
        
        } );

    }

    /**
     * Generates an ics file
     * 
     * @param $args The args for megacal_get_events - If empty, start_date = -2 Years & end_date = +2 Years.
     */
    private function megacal_generate_ics( $args = array() ) {

        if( empty( $args ) ) {

            $start_date = $this->megacal_get_wp_datetime( '-2 Years' );
            $end_date = $this->megacal_get_wp_datetime( '+2 Years' );

            $args = array( 
                'start_date' => $start_date->format( 'Y-m-d' ),
                'end_date' => $end_date->format( 'Y-m-d' ),
            );

        }

        $events = $this->megacal_get_public_events( $args );

        if( $events instanceof WP_Error ) {

            wp_die( $events->get_error_message() );

        }

        $timezone = wp_timezone();

        $cal = Vcalendar::factory( [ Vcalendar::UNIQUE_ID => site_url() ] )
                ->setCalscale( Vcalendar::GREGORIAN )
                ->setMethod( Vcalendar::PUBLISH )
                ->setXprop(
                    Vcalendar::X_WR_CALNAME,
                    html_entity_decode( get_bloginfo( 'site_name' ) . ' Calendar' )
                )
                ->setXprop(
                    Vcalendar::X_WR_TIMEZONE,
                    $timezone->getName()
                );

        
        foreach( $events as $event ) {

            if( !$event->get_published() ) {
                continue;
            }

            $start_date = $this->megacal_fmt_date_time_for_ics( $event->get_event_date(), $event->get_start_time() );
            $end_date = $this->megacal_fmt_date_time_for_ics( $event->get_event_date(), $event->get_end_time() );

            $calEvent = $cal->newVevent()
                ->setTransp( Vcalendar::OPAQUE )
                ->setClass( Vcalendar::P_BLIC )
                ->setSummary( $event->get_title() )
                ->setDescription( $event->get_description() )
                ->setLocation( $event->get_venue()->get_name() )
                ->setDtstart( $start_date['val'], $start_date['type'] )
                ->setDtend( $end_date['val'], $end_date['type'] );

        }

        $calString = $cal->vtimezonePopulate()->createCalendar();

        // Set the headers
        header('Content-type: text/calendar; charset=utf-8');
        header('Content-Disposition: attachment; filename="event-export.ics"');
        
        echo $calString;

    }

    private function megacal_load_event_detail( $event_id ) {

        try {

            $event_detail_response = MegaCalAPI::request( MegaCalAPI::EVENT_REQUEST, 'get_event', array(
                'event_id' => $event_id,
            ) );

            if( !( $event_detail_response instanceof EventDetailResponse ) ) {
                wp_die( 'Error: Could not load event details' );
            }

            $event = $event_detail_response->get_event();

            require_once megacal_get_template_part( 'views/megacal', 'event-detail', false );

        } catch( ApiException $e ) {

            if( 404 === $e->getCode() ) {

                // gracefully fail for 404s
                global $wp_query;
                $wp_query->set_404();
                status_header( 404 );
                get_template_part( 404 ); 
                exit();

            } else {
                
                wp_die( $e->getMessage() );

            }

        }

    }

    /**
     * Gets the date & time formatted for ics specifications
     * 
     * @param $date The date
     * @param $time The time
     * 
     * return array The expected format for use with a VCalendar object
     */
    private function megacal_fmt_date_time_for_ics( $date, $time ) {

        $dt = $this->megacal_get_wp_datetime( $date . ' ' . $time );

        return array( 
            'val' => !empty( $time ) ? $dt->format( 'Ymd\THis' ) : $dt->format( 'Ymd' ), 
            'type' => !empty( $time ) ? [Vcalendar::VALUE => Vcalendar::DATE_TIME] : [Vcalendar::VALUE => Vcalendar::DATE],
        );

    }

    /** 
     * Utility to get current date/time as a PHP DateTime object using wp timezone 
     *
     *  @return DateTimeImmutable The DateTimeImmutable object for "today" based on wp timezone 
     **/
    private function megacal_get_wp_datetime( $dt_string = 'now' ) {

        $timezone = wp_timezone();
        $dt = new DateTimeImmutable( $dt_string, $timezone );

        return $dt;

    }

    /** Fires on admin_init **/
    public function megacal_admin_init() {

        $this->megacal_register_settings();
        $this->megacal_register_custom_buttons();

    }

    function megacal_register_settings() {

        $settings = self::megacal_get_settings();
        
        //Register a new section on the settings page
        add_settings_section(
            'megacal_settings_section',
            'General Settings',
            array($this, 'megacal_settings_section'),
            MEGACAL_SETTINGS_SLUG
        );

        add_settings_field(
            'megacal_default_style',
            'Default List Style',
            array( $this, 'megacal_default_style_field' ),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_default_style',
                'class' => 'megacal_row'
            ]
        );

        //Register the API Key field
        add_settings_field(
            'megacal_access_token',
            'Access Token',
            array($this, 'megacal_token_field'),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_access_token',
                'class' => !empty( $settings['megacal_access_token'] ) ? 'hidden' : 'megacal_row'
            ]
        );

        // refresh token field
        add_settings_field(
            'megacal_refresh_token',
            'Refresh Token',
            array($this, 'megacal_token_field'),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_refresh_token',
                'class' => !empty( $settings['megacal_refresh_token'] ) ? 'hidden' : 'megacal_row'
            ]
        );

        // EOD Cutoff
        /*
        TODO: Implement this functionality when we have better ways to query upcoming
        add_settings_field(
            'megacal_eod_cutoff',
            'End of Day Cutoff Time',
            array( $this, 'megacal_eod_cutoff_field' ),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_eod_cutoff',
                'class' => 'megacal_row'
            ]
        );
        */

        // Default List Style
        add_settings_field(
            'megacal_default_style',
            'Default List Style',
            array( $this, 'megacal_default_style_field' ),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_default_style',
                'class' => 'megacal_row'
            ]
        );

        // Ticket URL Label Override
        add_settings_field(
            'megacal_event_url_label',
            'Event URL Label',
            array($this, 'megacal_event_url_label_field'),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_event_url_label',
                'class' => 'megacal_row'
            ]
        );

        add_settings_field(
            'megacal_time_fmt',
            'Event Time Format',
            array( $this, 'megacal_time_fmt_field' ),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_time_fmt',
                'class' => 'megacal_row'
            ]
        );

        //Register no events message
        add_settings_field(
            'megacal_no_event_msg',
            'Message shown when no events found',
            array($this, 'megacal_no_event_msg_field'),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_no_event_msg',
                'class' => 'megacal_row'
            ]
        );

        add_settings_field(
            'megacal_frequent_handles',
            'Share to Saved Calendars',
            array($this, 'megacal_frequent_handles_field'),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_frequent_handles',
                'class' => 'megacal_row'
            ]
        );

        add_settings_field(
            'megacal_default_handles',
            'Default Shares',
            array($this, 'megacal_default_handles_field'),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_default_handles',
                'class' => 'megacal_row'
            ]
        );

        add_settings_field(
            'megacal_default_category',
            'Default Event Category',
            array( $this, 'megacal_default_category_field' ),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_default_category',
                'class' => 'megacal_row'
            ]
        );

        add_settings_field(
            'megacal_events_url',
            'Events URL',
            array($this, 'megacal_events_url_field'),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'megacal_events_url',
                'class' => 'megacal_row'
            ]
        );

        add_settings_field(
            'megacal_hidden_handle',
            '',
            array( $this, 'megacal_hidden_field' ),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'handle',
                'class' => 'hidden'
            ]
        );

        add_settings_field(
            'megacal_hidden_user_id',
            '',
            array( $this, 'megacal_hidden_field' ),
            MEGACAL_SETTINGS_SLUG,
            'megacal_settings_section',
            [
                'label_for' => 'user_id',
                'class' => 'hidden'
            ]
        );
        
    }

    function megacal_register_custom_buttons() {

        // Priority 20 here is to ensure that
        // our media button appears after the 
        // default one 
        add_action( 'media_buttons', array( $this, 'megacal_show_shortcode_button'), 20 );

    }

    function megacal_show_shortcode_button() {

        echo '
            <a href="#" id="megacal-insert-shortcode" class="button">
                <i class="fui-calendar"></i>                
                Add Calendar
            </a>
        ';            
    }

    function megacal_register_admin_bar_menu( $admin_bar ) {

        if( !current_user_can( MEGACAL_PLUGIN_VISIBILITY_CAP ) ) 
            return;

        $admin_bar->add_menu( array(
            'id'    => 'megacal-admin-menu',
            'title' => 'MegaCal',
            'href'  => admin_url( 'admin.php?page=' . MEGACAL_MANAGE_SLUG ),
            'meta'  => array(
                'title' => __( 'MegaCal' ),
            ),
        ));

        $admin_bar->add_menu( array(
            'id'    => 'megacal-flush-event-cache',
            'parent' => 'megacal-admin-menu',
            'title' => 'Flush Event Cache',
            'href'  => wp_nonce_url( admin_url( 'admin-post.php?action=megacal_flush_event_cache' ), '_megacal_flush_event_cache_nonce' ),
            'meta'  => array(
                'title' => __( 'Flush Event Cache' ),
            ),
        ));

    }

    function megacal_admin_post_flush_event_cache() {
        
        if( !wp_verify_nonce( sanitize_key( $_GET['_wpnonce'] ), '_megacal_flush_event_cache_nonce' ) )
            wp_die( 'Not Allowed' );

        if( empty( $_SERVER['HTTP_REFERER'] ) )
            wp_die( 'Not Allowed' );

        $this->megacal_flush_event_cache();

        wp_redirect( $_SERVER['HTTP_REFERER'] );
        exit;

    }

    /** Enqueues plugin admin scripts **/
    public function megacal_enqueue_admin_scripts() {

        $hidden_settings = self::megacal_get_settings( 'megacal_hidden_options' );

        wp_enqueue_style(
            'megacal-admin-styles', 
            plugins_url( '/assets/build/css/admin.css', MEGACAL_PLUGIN ), 
            array(), 
            filemtime( untrailingslashit( plugin_dir_path( __FILE__ ) ) . '/assets/build/css/admin.css' )
        );

        wp_enqueue_script(
            'megacal-admin-scripts', 
            plugins_url( '/assets/build/js/admin.min.js', MEGACAL_PLUGIN ), 
            array( 'jquery', 'megacal-admin-stripe-js' ),
            filemtime( untrailingslashit( plugin_dir_path( __FILE__ ) ) . '/assets/build/js/admin.min.js' )
        );
        wp_localize_script('megacal-admin-scripts', 'megacal_admin_script_opts', array(
            'ajax_url' => admin_url( 'admin-ajax.php' ),
            'base_url' => plugins_url( '', MEGACAL_PLUGIN ),
            'default_image_path' => megacal_get_default_event_image_path(),
            'settings_url' => MEGACAL_SETTINGS_URL,
            'upgrade_url' => MEGACAL_UPGRADE_URL,
            'user_handle' => ( !empty( $hidden_settings['handle'] ) ) ? $hidden_settings['handle'] : '',
            'time_fmt_setting' => $this->megacal_get_time_fmt( 'js' ),
        ));

        wp_enqueue_script(
            'megacal-admin-stripe-js', 
            'https://js.stripe.com/v3/', 
            array(),
            null
        );

        $ajax_shortcode_options_url = add_query_arg( array(
            'action' => 'load_shortcode_options',
            '_nonce' => wp_create_nonce( 'load-shortcode-modal-nonce' )
        ), admin_url( 'admin-ajax.php' ) );

        wp_localize_script( 'megacal-admin-scripts', 'ajax_shortcode_options', array( 
                'url' => $ajax_shortcode_options_url,
            ) 
        );

    }

    /** Enqueues plugin front-end scripts **/
    public function megacal_enqueue_scripts() {

        $settings = self::megacal_get_settings();
        
        wp_enqueue_style(
            'megacal-styles', 
            plugins_url( '/assets/build/css/styles.css', MEGACAL_PLUGIN ),
            array(), 
            filemtime( untrailingslashit( plugin_dir_path( __FILE__ ) ) . '/assets/build/css/styles.css' )
        );

        //Scripts
        wp_enqueue_script(
            'megacal-scripts', 
            plugins_url( '/assets/build/js/main.min.js', MEGACAL_PLUGIN ), 
            array( 'jquery' ),
            filemtime( untrailingslashit( plugin_dir_path( __FILE__ ) ) . '/assets/build/js/main.min.js' )
        );

        wp_localize_script('megacal-scripts', 'megacal_script_opts', array(
            'ajax_url' => admin_url( 'admin-ajax.php' ),
            'base_url' => plugins_url( '', MEGACAL_PLUGIN ),
            'default_image_path' => megacal_get_default_event_image_path(),
            'event_url' => site_url( trailingslashit( $settings['megacal_events_url'] ) ),
            'time_fmt_setting' => $this->megacal_get_time_fmt( 'js' ),
        ));

    }

    /** Validate Input **/
    public function megacal_validate_input( $input ) {
        $output = array();

        foreach ($input as $key => $value) {

            if (isset($input[$key])) {

                // General Sanitization
                if( is_numeric( $input[$key] ) ) {
                
                    $output[$key] = intval( sanitize_text_field( stripslashes( $input[$key] ) ) );
                    
                } else if( is_string( $input[$key] ) ) {
                
                    $output[$key] = sanitize_text_field( stripslashes( $input[$key] ) );
                
                } elseif( is_array( $input[$key] ) ) {
                  
                    foreach( $input[$key] as $v ) {
                        $output[$key][] = sanitize_text_field( stripslashes( $v ) );
                    }

                }

                // Specific Validation Rules
                if ($key == 'megacal_access_token' && !is_string( $input[$key] ) ) {
                    $output[$key] = '';
                }

                if ($key == 'megacal_no_event_msg' && !is_string($input[$key])) {
                    $output[$key] = '';
                }

                if( $key == 'megacal_default_category' && !is_numeric( $input[$key] ) ) {
                    $output[$key] = '';
                }

                if( $key == 'megacal_events_url' ) {
                    $output[$key] = preg_replace( '/[^A-za-z\/]/m', '', $output[$key] );
                    $output[$key] = preg_replace( '#/+#', '/', $output[$key] );
                }

            }
        }

        return apply_filters( 'megacal_validate_input', $output, $input );
    }

    public function megacal_update_settings( $old, $new ) {

        set_transient( 'megacal_do_rewrite_flush', true, 30 * MINUTE_IN_SECONDS );

    }

    /** Adds options to the admin menu **/
    public function admin_menu() {

        $settings = self::megacal_get_settings();

        //Main Tab
        $default_page_render = !empty( $settings['megacal_access_token'] ) ? 'megacal_render_manage_page' : 'megacal_render_settings_page';
        $default_page_slug = !empty( $settings['megacal_access_token'] ) ? MEGACAL_MANAGE_SLUG : MEGACAL_SETTINGS_SLUG;

        add_menu_page(
            'MegaCalendar', 
            'MegaCalendar', 
            MEGACAL_PLUGIN_VISIBILITY_CAP, 
            $default_page_slug, 
            array($this, $default_page_render), 
            'dashicons-calendar'
        );

        if( !empty( $settings['megacal_access_token'] ) ) { 
            
            add_submenu_page( 
                $default_page_slug, 
                'Add/Manage Events', 
                'Add/Manage Events', 
                MEGACAL_PLUGIN_VISIBILITY_CAP, 
                MEGACAL_MANAGE_SLUG,
                ''
            );      

            //Settings Link
            add_submenu_page( 
                $default_page_slug, 
                'MegaCal Settings', 
                'Settings', 
                MEGACAL_PLUGIN_VISIBILITY_CAP, 
                MEGACAL_SETTINGS_SLUG,
                array( $this, 'megacal_render_settings_page' ) 
            );
        
        } else {

            //Settings Link
            add_submenu_page( 
                $default_page_slug, 
                'MegaCal Settings', 
                'Settings', 
                MEGACAL_PLUGIN_VISIBILITY_CAP, 
                MEGACAL_SETTINGS_SLUG
            );

            //Add Events Link
            add_submenu_page( 
                $default_page_slug, 
                'Add/Manage Events', 
                'Add/Manage Events', 
                MEGACAL_PLUGIN_VISIBILITY_CAP, 
                MEGACAL_MANAGE_SLUG, 
                array( $this, 'megacal_render_manage_page' ) 
            );      
        
        }

        //Upgrade Link
        if( !empty( $settings['megacal_access_token'] ) ) { 
            if( !$this->megacal_is_pro_account() ) {
                add_submenu_page( 
                    $default_page_slug, 
                    'Upgrade to Pro', 
                    'Upgrade to Pro', 
                    MEGACAL_PLUGIN_VISIBILITY_CAP, 
                    MEGACAL_UPGRADE_SLUG, 
                    array( $this, 'megacal_render_upgrade_page' ) 
                );
            }       
        }
    
    }

    public function megacal_render_manage_page() {

        // check user capabilities
        if( !current_user_can( MEGACAL_PLUGIN_VISIBILITY_CAP ) ) {
            return;
        }

        require_once( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/megacal-manage-page.php' );

    }

    public function megacal_render_upgrade_page() {

        // check user capabilities
        if( !current_user_can( MEGACAL_PLUGIN_VISIBILITY_CAP ) ) {
            return;
        }

        $cancelled = !empty( $_GET['cancel'] ) && boolval( $_GET['cancel'] ) ? true : false;
        if( $cancelled ) {
            add_settings_error( 'megacal_options', 'megacal_payment_cancel', 'Not Upgraded: No payment has been made', 'warning' );
        }

        // show error/update messages
        settings_errors( 'megacal_options' );

        require_once( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/megacal-upgrade-page.php' );

    }

    /** The plugin settings page **/
    public function megacal_render_settings_page() {

        require_once( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/megacal-settings-page.php' );

    }

    /** Used for customizing the general settings section **/
    public function megacal_settings_section($args) {
        //Nothing to do here...
    }

    /** The Token Fields
     **
     **    @param $args The arguments passed to the register function
     **/
    public function megacal_token_field( $args ) {
        //Get the existing options
        $settings = self::megacal_get_settings();
        $error = "";

        $field_type = empty( $settings[$args['label_for']] ) ? 'password' : 'hidden';
        ?>

            <input type="<?php esc_attr_e( $field_type ); ?>" id="<?php echo esc_attr( $args['label_for'] ); ?>"
                name="megacal_options[<?php echo esc_attr( $args['label_for'] ); ?>]" 
                value="<?php echo !empty( $settings[$args['label_for']] ) ? esc_attr( $settings[$args['label_for']] ) : ''; ?>" />
        
            <?php if( !empty( $error ) ): ?>
                <p>Error: <?php echo esc_html( $error ); ?></p>
            <?php endif; ?>

        <?php
    }

    public function megacal_event_url_label_field( $args ) {
        
        $default = 'Tickets';
        include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/admin/settings/field-text.php';

    }

    public function megacal_time_fmt_field( $args ) {

        //Get the existing options
        $settings = self::megacal_get_settings();
        $error = "";
        $val = !empty( $settings[$args['label_for']] ) ? $settings[$args['label_for']] : '';
        ?>
        <select id="<?php echo esc_attr($args['label_for']); ?>" name="megacal_options[<?php echo esc_attr($args['label_for']); ?>]">
            <option value="12-hour" <?php echo '12-hour' === $val ? 'selected' : ''; ?>>12 Hour (h:mm am/pm)</option>
            <option value="24-hour" <?php echo '24-hour' === $val ? 'selected' : ''; ?>>24 Hour (hh:mm)</option>
        </select>
        <?php

    }

    public function megacal_no_event_msg_field( $args ) {
     
        include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/admin/settings/field-text.php';

    }

    public function megacal_eod_cutoff_field( $args ) {

        //Get the existing options
        $settings = self::megacal_get_settings();
        $error = "";
        ?>
        <select id="<?php echo esc_attr( $args['label_for'] ); ?>" name="megacal_options[<?php echo esc_attr( $args['label_for'] ); ?>]">
        <?php for( $i = 1; $i < 12; $i++ ): ?>
                <?php 
                    $formatted_val = $i . ':00 AM';
                    $selected = $formatted_val == $settings['megacal_eod_cutoff'] ? 'selected' : '';
                ?>
                <option value="<?php esc_attr_e( $formatted_val ); ?>" <?php esc_attr_e( $selected ); ?>><?php esc_html_e( $formatted_val ); ?></option>
            <?php endfor; ?>
            
            <?php 
                $formatted_val = '12:00 PM';
                $selected = $formatted_val == $settings['megacal_eod_cutoff'] ? 'selected' : '';
            ?>
            <option value="<?php esc_attr_e( $formatted_val ); ?>" <?php esc_attr_e( $selected ); ?>><?php esc_html_e( $formatted_val ); ?></option>
            
            <?php for( $i = 1; $i < 12; $i++ ): ?>
                <?php 
                    $formatted_val = $i . ':00 PM';
                    $selected = $formatted_val == $settings['megacal_eod_cutoff'] ? 'selected' : '';
                ?>
                <option value="<?php esc_attr_e( $formatted_val ); ?>" <?php esc_attr_e( $selected ); ?>><?php esc_html_e( $formatted_val ); ?></option>
            <?php endfor; ?>
            
            <?php 
                $formatted_val = '12:00 AM';
                $selected = $formatted_val == $settings['megacal_eod_cutoff'] ? 'selected' : '';
            ?>
            <option value="<?php esc_attr_e( $formatted_val ); ?>" <?php esc_attr_e( $selected ); ?>><?php esc_html_e( $formatted_val ); ?></option>

        </select>
        <?php

    }

    public function megacal_default_style_field( $args ) {
        //Get the existing options
        $settings = self::megacal_get_settings();
        $error = "";
        ?>
        <select id="<?php echo esc_attr($args['label_for']); ?>" name="megacal_options[<?php echo esc_attr($args['label_for']); ?>]">
            <option value="full" <?php echo ( $settings[$args['label_for']] == 'full' ) ? 'selected' : ''; ?>>Detailed Events List with Pictures</option>
            <option value="compact"  <?php echo ( $settings[$args['label_for']] == 'compact' ) ? 'selected' : ''; ?>>Simple Compact Event List</option>
            <option value="simple"  <?php echo ( $settings[$args['label_for']] == 'simple' ) ? 'selected' : ''; ?>>Simple Event List with Pictures</option>
        </select>
        <?php
    }

    public function megacal_frequent_handles_field( $args ) {
    
        $hidden_settings = self::megacal_get_settings( 'megacal_hidden_options' );

        $placeholder = '';
        include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/admin/settings/field-text.php';

        ?>
        <?php if( !empty( $hidden_settings['handle'] ) ): ?>
            <p class="small">Enter user's handle, comma separated. Your handle is: <?php esc_html_e( $hidden_settings['handle'] ); ?></p>
        <?php endif; ?>
        <?php
    }

    public function megacal_default_handles_field( $args ) {
        //Get the existing options
        $settings = self::megacal_get_settings();
        $error = "";
        
        if( empty( $settings['megacal_frequent_handles'] ) ) {
            echo '<p>First add some handles to the field above</p>';
            return;
        }

        $settings[$args['label_for']] = empty( $settings[$args['label_for']] ) ? array() : $settings[$args['label_for']];
        $handles = array_map( 'trim', explode( ',', $settings['megacal_frequent_handles'] ) );
        foreach( $handles as $handle ) {

            printf( 
                '<label for="megacal-default-handle-%s"><input type="checkbox" %s id="megacal-default-handle-%s" name="megacal_options[%s][]" value="%s" />%s</label><br />', 
                $handle,
                checked( in_array( $handle, $settings[$args['label_for']] ), true, false ),
                $handle,
                esc_attr( $args['label_for'] ),
                $handle,
                $handle
            );

        }

    }

    public function megacal_default_category_field( $args ) {
        //Get the existing options
        $settings = self::megacal_get_settings();

        $my_categories = $this->megacal_get_my_category_list();

       ?>
            <select <?php echo ( empty( $my_categories ) ) ? 'disabled' : ''; ?> name="megacal_options[<?php esc_attr_e( $args['label_for'] ); ?>]">
                <?php foreach( $my_categories as $cat ): ?>
                    <?php $selected = !empty( $settings[$args['label_for']] ) && $settings[$args['label_for']] == $cat->get_id() ? 'selected' : ''; ?>
                    <option value="<?php esc_attr_e( $cat->get_id() ); ?>" <?php esc_attr_e( $selected ); ?>>
                        <?php esc_html_e( $cat->get_name() ); ?>
                    </option>
                <?php endforeach; ?>

            </select>

            <?php if( empty( $my_categories ) ): ?>
                <p>Modify this setting after you have created some event categories</p>
            <?php endif; ?>

        <?php
    }

    public function megacal_events_url_field( $args ) {
        //Get the existing options
        $settings = self::megacal_get_settings();
        $default = 'events/';
        
        include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/admin/settings/field-text.php';

        ?>
        <p class="small">Try changing this if you are having issues with other calendar plugins.</p>
        <?php
    }

    public function megacal_hidden_field( $args ) {
        //Get the existing options
        $hidden_settings = self::megacal_get_settings( 'megacal_hidden_options' );
        ?>
        <input type="hidden" id="<?php echo esc_attr($args['label_for']); ?>"
                name="megacal_hidden_options[<?php echo esc_attr($args['label_for']); ?>]"
                value="<?php echo !empty( $hidden_settings[$args['label_for']] ) ? esc_attr( $hidden_settings[$args['label_for']] ) : ''; ?>"/>
        <?php
    }

    //WP AJAX hook functions
    public function megacal_ajax_check_handle() {
        
        check_ajax_referer( '_megacal_check_handle_nonce', '_nonce' );

        $handle = sanitize_text_field( $_POST['handle'] );

        if( empty( $handle ) ) {
            wp_send_json_error( array( 'message' => 'Handle cannot be empty' ) );
        }

        try {

            $response = MegaCalAPI::request( 
                MegaCalAPI::AUTH_REQUEST, 
                'check_handle', 
                array( 'handle' => $handle ) 
            );

        } catch( ApiException $e ) {

            wp_send_json_error( array( 'message' => $e->get_simple_message() ) );

        }

        if( !( $response instanceof CheckHandleResponse ) ) {
            wp_send_json_error( array( 'message' => 'Something went wrong' ) );
        }

        wp_send_json_success( array( 'unique' => $response->get_unique() ) );

    } 

    public function megacal_ajax_register() {

        check_ajax_referer( '_megacal_register_nonce', '_nonce' );

        $firstname = sanitize_text_field( stripslashes( $_POST['firstname'] ) );
        if( empty( $firstname ) ) {
            wp_send_json_error( array( 'message' => 'First Name cannot be empty' ) );
        }

        $lastname = sanitize_text_field( stripslashes( $_POST['lastname'] ) );
        if( empty( $lastname ) ) {
            wp_send_json_error( array( 'message' => 'Last Name cannot be empty' ) );
        }

        $handle = sanitize_text_field( stripslashes( $_POST['handle'] ) );
        if( empty( $handle ) ) {
            wp_send_json_error( array( 'message' => 'Handle cannot be empty' ) );
        }

        $email = sanitize_email( stripslashes( $_POST['email'] ) );
        if( empty( $email ) ) {
            wp_send_json_error( array( 'message' => 'Email cannot be empty' ) );
        }

        $phone = sanitize_text_field( stripslashes( $_POST['phone'] ) );

        $calendarName = sanitize_text_field( stripslashes( $_POST['calendarName'] ) );
        if( empty( $calendarName ) ) {
            wp_send_json_error( array( 'message' => 'Calendar name cannot be empty' ) );
        }

        try {

            $response = MegaCalAPI::request(
                MegaCalAPI::AUTH_REQUEST,
                'register',
                array(
                    'first_name' => $firstname,
                    'last_name' => $lastname,
                    'handle' => $handle,
                    'email' => $email,
                    'phone' => $phone,
                    'calendar_name' => $calendarName,
                )
            );
        
        } catch( ApiException $e ) {

            wp_send_json_error( array( 'message' => $e->get_simple_message() ) );

        }

        if( !( $response instanceof RegisterResponse ) ) {
            wp_send_json_error( array( 'message' => 'Something went wrong' ) );
        }

        $settings = self::megacal_get_settings();
        $settings['megacal_access_token'] = $response->get_access_token();
        $settings['megacal_refresh_token'] = $response->get_refresh_token();

        $updated = update_option( 'megacal_options', $settings );

        if( false === $updated ) {

            wp_send_json_error( array( 'message' => 'Unable to save Access & Refresh Tokens' ) );
            
        }

        $hidden_settings = self::megacal_get_settings( 'megacal_hidden_options' );
        $hidden_settings['handle'] = $handle;

        $updated = update_option( 'megacal_hidden_options', $hidden_settings );

        if( false === $updated ) {
            wp_send_json_error( array( 'message' => 'Unable to save handle' ) );
        }

        wp_send_json_success( array(
            'access_token' => $response->get_access_token(),
            'refresh_token' => $response->get_refresh_token(),
        ) );

    }

    public function megacal_ajax_save_event() {

        check_ajax_referer( '_megacal_event_upsert_nonce', '_nonce' );
        
        $field_names = array(
            'eventId', 'eventTitle', 'eventDate', 'eventAllDay', 'eventStartTime', 'eventEndTime', 'eventImg', 'eventVenueId', 
            'eventVenueName', 'eventCatId', 'eventCatName', 'eventVenueLocation', 'eventOrganizer', 'eventFacebookUrl', 
            'eventTicketUrl', 'eventPrice', 'eventTaggedUsersExtra', 'megacalEventDescription', 'megacalEventPrivateNotes', 
            'published', 'eventChangeType',
        );

        foreach( $field_names as $key ) {
            if( !isset( $_POST[$key] ) ) {
                wp_send_json_error( array( 'message' => 'Something isn\'t right: Missing parameter ' . $key ) );
            }

            // extra escaping causing issues
            $_POST[$key] = stripslashes( $_POST[$key] );
        }

        $settings = $this->megacal_get_settings();
        $updating = ( !empty( $_POST['eventId'] ) && is_numeric( $_POST['eventId'] ) );

        if( empty( $_POST['eventTitle'] ) ) {
            wp_send_json_error( array( 'message' => 'Event Title is required' ) );
        } 

        if( empty( $_POST['eventDate'] ) ) {
            wp_send_json_error( array( 'message' => 'Event Date is required' ) );
        }

        if( !$this->megacal_is_valid_date( $_POST['eventDate'], 'm/d/Y' ) ) {
            wp_send_json_error( array( 'message' => 'Invalid Event Date' ) );
        }

        if( empty( $_POST['eventVenueName'] ) && empty( $_POST['eventVenueId']) ) {
            wp_send_json_error( array( 'message' => 'Venue is required' ) );
        } 

        if( false === boolval( $_POST['eventAllDay'] ) ) {

            if( empty( $_POST['eventStartTime'] ) || empty( $_POST['eventEndTime'] ) ) {
                wp_send_json_error( array( 'message' => 'Start & End times required for non-all-day events' ) );
            }

            if( !$this->megacal_is_valid_time( $_POST['eventStartTime'] ) || !$this->megacal_is_valid_time( $_POST['eventEndTime'] ) ) {
                wp_send_json_error( array( 'message' => 'Invalid start or end time' ) );
            }

            $event_start_time = $this->megacal_fmt_time( $_POST['eventStartTime'] );
            $event_end_time = $this->megacal_fmt_time( $_POST['eventEndTime'] );

        } else {
            
            $event_start_time = '';
            $event_end_time = '';

        }

        if( !empty( $_POST['eventTaggedUsers'] ) && !is_array( $_POST['eventTaggedUsers'] ) ) {
            wp_send_json_error( array( 'message' => 'Unexpected value for tagged users' ) );
        }


        if( !empty( $_POST['eventRecurrence'] ) ) {

            if( intval( $_POST['eventRecurrenceRepetition'] ) != $_POST['eventRecurrenceRepetition'] || intval( $_POST['eventRecurrenceRepetition'] ) < 1 ) {
                wp_send_json_error( array( 'message' => 'Event recurrence repetition must be 1 or greater' ) );
            }
    
            if( intval( $_POST['eventRecurrenceEndOccurrence'] ) != $_POST['eventRecurrenceEndOccurrence'] || intval( $_POST['eventRecurrenceEndOccurrence'] ) < 1 ) {
                wp_send_json_error( array( 'message' => 'Event recurrence repetition must be 1 or greater' ) );
            }
    
            if( !$this->megacal_is_valid_date( $_POST['eventRecurrenceEndDate'], 'm/d/Y' ) ) {
                wp_send_json_error( array( 'message' => 'Invalid Event Recurrence End Date' ) );
            }
    
            $event_recurrence = sanitize_text_field( $_POST['eventRecurrence'] );
            $event_recurrence_day_of_week = sanitize_text_field( $_POST['eventRecurrenceDayOfWeek'] );
            $event_recurrence_week_of_month = intval( $_POST['eventRecurrenceWeekOfMonth'] );
            $event_recurrence_last_day_of_week = $_POST['eventRecurrenceLastDayOfWeek'] === 'true' ? true : false;
            $event_recurrence_day_of_month = intval( $_POST['eventRecurrenceDayOfMonth'] );
            $event_recurrence_month = sanitize_text_field( $_POST['eventRecurrenceMonth'] );
            $event_recurrence_repetition = intval( $_POST['eventRecurrenceRepetition'] );
            $event_recurrence_custom_type = sanitize_text_field( $_POST['eventRecurrenceCustomType'] );
            $event_recurrence_custom_monthly_freq = sanitize_text_field( $_POST['eventRecurrenceCustomMonthlyFreq'] );
            $event_recurrence_end = sanitize_text_field( $_POST['eventRecurrenceEnd'] );
            $event_recurrence_end_date = date( 'Y-m-d', strtotime( $_POST['eventRecurrenceEndDate'] ) );
            $event_recurrence_end_occurrence = intval( $_POST['eventRecurrenceEndOccurrence'] );
            $event_recurrence_weekly_days = empty( $_POST['eventRecurrenceWeeklyDays'] ) 
            ? array() 
            : $this->megacal_sanitize_and_filter_array( $_POST['eventRecurrenceWeeklyDays'] );
        
        }
        
        $event_id = intval( $_POST['eventId'] );
        $event_title = sanitize_text_field( $_POST['eventTitle'] );
        $event_date = date( 'Y-m-d', strtotime( $_POST['eventDate'] ) );

        $event_img = esc_url( $_POST['eventImg'] );
        $event_venue_id = ( !empty( $_POST['eventVenueId'] ) ) ? intval( $_POST['eventVenueId'] ) : false;
        $event_venue_name = sanitize_text_field( $_POST['eventVenueName'] );
        $event_cat_id = ( !empty( $_POST['eventCatId'] ) ) ? intval( $_POST['eventCatId'] ) : false;
        $event_cat_name = sanitize_text_field( $_POST['eventCatName'] );
        $event_venue_location = sanitize_text_field( $_POST['eventVenueLocation'] );
        $event_organizer = wp_kses_post( $_POST['eventOrganizer'] );
        $event_facebook_url = esc_url( $_POST['eventFacebookUrl'] );
        $event_ticket_url = esc_url( $_POST['eventTicketUrl'] );
        $event_price = sanitize_text_field( $_POST['eventPrice'] );
        $megacal_event_description = wp_kses_post( $_POST['megacalEventDescription'] );
        $megacal_event_private_notes = wp_kses_post( $_POST['megacalEventPrivateNotes'] );
        $published = boolval( $_POST['published'] );
        $event_change_type = sanitize_text_field( $_POST['eventChangeType'] );

        // Sanitize & Merge tagged user fields
        $event_tagged_users =  empty( $_POST['eventTaggedUsers'] ) 
            ? array() 
            : $this->megacal_sanitize_and_filter_array( $_POST['eventTaggedUsers'] );

        $event_tagged_users_extra = $this->megacal_sanitize_and_filter_array( explode( ',', $_POST['eventTaggedUsersExtra'] ) );

        $event_tagged_users = array_merge( $event_tagged_users, $event_tagged_users_extra );

        $venue = array();
        if( $event_venue_id ) {
            
            $all_venues = $this->megacal_get_venue_list();
            $venue['id'] = $event_venue_id;

            foreach( $all_venues as $v ) {

                if( $v->get_id() !== $venue['id'] )
                    continue;

                $venue['name'] = $v->get_name();
                break;

            }

        } else {

            $venue = array(
                'name' => $event_venue_name,
                'location' => $event_venue_location,
            );

        }

        $cat = array();
        if( $event_cat_id ) {
            
            $all_cats = $this->megacal_get_my_category_list();
            $cat['id'] = $event_cat_id;

            foreach( $all_cats as $ec ) {
            
                if( $ec->get_id() !== $cat['id'] )
                    continue;

                $cat['name'] = $ec->get_name();
                break;

            }

        } else if( !empty( $event_cat_name ) ) {

            $cat = array(
                'name' => $event_cat_name,
            );

        } else if( !empty( $settings['megacal_default_category'] ) ) {

            $cat = array(
                'id' => intval( $settings['megacal_default_category'] ),
            );

        } else {

            $my_categories = !empty( $this->megacal_get_my_category_list() ) ? $this->megacal_get_my_category_list() : array();
            $default_id = false;

            foreach( $my_categories as $c ) {
                
                if( strtolower( $c->get_name() ) == strtolower( apply_filters( 'megacal_default_category_name', MEGACAL_DEFAULT_CATEGORY_NAME ) ) ) {
                    $default_id = $c->get_id();
                    $settings['megacal_default_category'] = $default_id;
                    update_option( 'megacal_options', $settings );
                    break;
                }

            }

            if( !empty( $default_id ) && is_int( $default_id ) ) {

                $cat = array(
                    'id' => $default_id,
                );

            }

        }

        $params = array(

            'title' => $event_title,
            'event_date' => $event_date,
            'start_time' => $event_start_time,
            'end_time' => $event_end_time,
            'image_url' => $event_img,
            'venue' => $venue,
            'event_category' => array( 'name' => apply_filters( 'megacal_default_category_name', MEGACAL_DEFAULT_CATEGORY_NAME ) ),
            'organizer' => $event_organizer,
            'facebook_url' => $event_facebook_url,
            'ticket_url' => $event_ticket_url,
            'price_details' => $event_price,
            'description' => $megacal_event_description,
            'private_note' => $megacal_event_private_notes,
            'tagged_users' => $event_tagged_users,
            'published' => $published,
            
        );

        if( !empty( $cat ) ) {
            $params['event_category'] = $cat;
        }
        
        if( $updating ) {
            $params['event_id'] = $event_id;
            $params['change_type'] = $event_change_type;
        }

        if( !empty( $_POST['eventRecurrence'] ) ) {

            // Handle event recurrence
            if( in_array( $event_recurrence, EventRecurrenceDetail::RECURRENCE_TYPES ) ) {
    
                $recurrence_data = $this->megacal_setup_recurrence_details( array(
                    'event_recurrence' => $event_recurrence,
                    'day_of_week' => $event_recurrence_day_of_week,
                    'week_of_month' => $event_recurrence_week_of_month,
                    'last_day_of_week' => $event_recurrence_last_day_of_week,
                    'day_of_month' => $event_recurrence_day_of_month,
                    'month' => $event_recurrence_month,
                    'repetition' => $event_recurrence_repetition,
                    'custom_type' => $event_recurrence_custom_type,
                    'custom_monthly_freq' => $event_recurrence_custom_monthly_freq,
                    'weekly_days' => $event_recurrence_weekly_days,
                    'end' => $event_recurrence_end,
                    'end_date' => $event_recurrence_end_date,
                    'end_occurrence' => $event_recurrence_end_occurrence,
                ) );
    
                if( !empty( $recurrence_data ) ) {
                    $recurrence = new EventRecurrenceDetail( $recurrence_data );
                    $params['recurrence'] = $recurrence;
                }
    
            }
 
        }

        $action = $updating ? 'update_event' : 'create_event';

        try {

            $response = MegaCalAPI::request( MegaCalAPI::EVENT_REQUEST, $action, $params );

        } catch( ApiException $e ) {

            $request = array( 
                'action' => $action, 
                'params' => $params 
            );

            wp_send_json_error( array( 'message' => $e->get_simple_message(), 'request' => $request ) );

        }

        if( !( $response instanceof EventUpsertResponse ) ) {
            
            wp_send_json_error( array( 'message' => 'Something went wrong' ) );

        }

        $event_id = $response->get_event_id();

        $this->megacal_flush_upsert_cache();
        $this->megacal_flush_event_cache();

        wp_send_json_success( array( 'eventId' => $event_id ) );

    }

    private function megacal_setup_recurrence_details( $recurrence_details = array() ) {

        if( empty( $recurrence_details ) ) {
            return array();
        }

        if( empty( $recurrence_details['event_recurrence'] ) ) {
            return array();
        }

        $type = $recurrence_details['event_recurrence'];
        $type_label = strtolower( $type );
        $data = array(
            'type' => $type,
        );

        switch( $type ) {

            case EventRecurrenceDetail::TYPE_WEEKLY:
                $data[$type_label] = array(
                    'dayOfWeek' => $recurrence_details['day_of_week'],
                );
                break;

            case EventRecurrenceDetail::TYPE_MONTHLY:
                $data[$type_label] = array(
                    'dayOfWeek' => $recurrence_details['day_of_week'],
                );

                if( $recurrence_details['last_day_of_week'] ) {
                    $data[$type_label]['lastDayOfWeek'] = true;
                } else {
                    $data[$type_label]['weekOfMonth'] = $recurrence_details['week_of_month'];
                }

                break;

            case EventRecurrenceDetail::TYPE_ANNUALLY:
                $data[$type_label] = array(
                    'dayOfMonth' => $recurrence_details['day_of_month'],
                    'month' => $recurrence_details['month']
                );
                break;

            case EventRecurrenceDetail::TYPE_WEEKDAY:
            case EventRecurrenceDetail::TYPE_DAILY:
                // no addtl details needed
                break;

            case EventRecurrenceDetail::TYPE_CUSTOM:
                $data[$type_label] = $this->megacal_build_custom_recurrence( $recurrence_details );
                break;

            default:
                error_log( sprintf( 'Unimplemented recurrence type: %s', $type ) );
                return array();
                break;

        }
        
        return $data;

    }

    private function megacal_build_custom_recurrence( $recurrence_details = array() ) {

        if( empty( $recurrence_details ) )
            return array();

        $data = array();
        $type = $recurrence_details['custom_type'];
        $type_label = strtolower( $type ) . 'Custom';
        $data = array(
            'type' => $type,
            'repetition' => $recurrence_details['repetition'],
        );

        $data[$type_label] = array();
        $end_condition = array();
        if( in_array( $recurrence_details['end'], array( 'date', 'occurrence' ) ) ) {

            if( 'date' == $recurrence_details['end'] ) {
                $end_condition['on'] = $recurrence_details['end_date'];
            } else if( 'occurrence' == $recurrence_details['end'] ) {
                $end_condition['afterOccurrence'] = $recurrence_details['end_occurrence'];
            }

            $data['endCondition'] = $end_condition;

        }

        switch( $type ) {
            case EventRecurrenceDetail::TYPE_DAILY:
            case EventRecurrenceDetail::TYPE_ANNUALLY:
                // nothing to do...
                break;
            case EventRecurrenceDetail::TYPE_WEEKLY:
                $data[$type_label]['repeatOn'] = $recurrence_details['weekly_days'];
                break;
            case EventRecurrenceDetail::TYPE_MONTHLY:
            
                if( 'day_of_month' == $recurrence_details['custom_monthly_freq'] ) {
                    $data[$type_label]['dayOfMonth'] = $recurrence_details['day_of_month'];
                } else {

                    $data[$type_label]['dayOfWeek'] = $recurrence_details['day_of_week'];
                    if( $recurrence_details['last_day_of_week'] ) {
                        $data[$type_label]['lastDayOfWeek'] = true;
                    } else {
                        $data[$type_label]['weekOfMonth'] = $recurrence_details['week_of_month'];
                    }
                
                }
                
                break;
            default:
                error_log( sprintf( 'Unimplemented recurrence type: %s', $type ) );
                return array();
                break;
        }

        return $data;

    }

    public function megacal_ajax_get_event_recurrence() {

        check_ajax_referer( '_megacal_event_recurrence_nonce', '_nonce' );
        
        $recurrence_details = null;

        if( $this->megacal_is_pro_account() ) {

            $date = $this->megacal_get_wp_datetime()->format( 'Y-m-d' );
            if( !empty( $_POST['date'] ) ) {

                if( !$this->megacal_is_valid_date( $_POST['date'], 'm/d/Y' ) ) {
                    wp_send_json_error( array( 'message' => sprintf( 'Invalid date value for recurrence: %s', esc_html( $_POST['date'] ) ) ) );
                }

                $date = $this->megacal_get_wp_datetime( $_POST['date'] )->format( 'Y-m-d' );

            }

            $show_recurrence = !empty( $_POST['showRecurrence'] ) && $_POST['showRecurrence'] === 'false' ? false : true;

            try {
        
                $response = MegaCalAPI::request( 
                    MegaCalAPI::EVENT_REQUEST, 
                    'get_event_recurrence', 
                    array( 'event_date' => $date ) 
                );

            } catch( ApiException $e ) {

                wp_send_json_error( array( 'message' => $e->get_simple_message() ) );

            }

            if( !( $response instanceof EventRecurrenceResponse ) ) {
                wp_send_json_error( array( 'message' => 'Something went wrong' ) );
            }

            $recurrence_details = $response->get_event_recurrence_details();

        }

        ob_start();

            require( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-event-recurrence-select.php' );
            $content = ob_get_contents();
        
        ob_end_clean();

        wp_send_json_success( array( 'content' => $content, 'recurrence_details' => $recurrence_details ) );

    }

    private function megacal_is_valid_time( $time ) {
        return $this->megacal_is_valid_date( $time, 'g : i A' );
    }

    private function megacal_is_valid_date( $date, $fmt = 'Y-m-d' ) {

        if( empty( $date ) )
            return false;

        $dateObj = DateTime::createFromFormat( $fmt, $date );
        return $dateObj && $dateObj->format( $fmt ) == strtoupper( $date );

    }

    private function megacal_fmt_time( $time, $inFmt = 'g : i A', $outFmt = 'H:i' ) {

        $dateObj = DateTime::createFromFormat( $inFmt, strtoupper( $time ) );
        return $dateObj->format( $outFmt );

    }

    private function megacal_sanitize_and_filter_array( $arr ) {

        $new_arr = array();

        foreach( $arr as $el ) {

            if( empty( sanitize_text_field( $el ) ) )
                continue;

            $new_arr[] = sanitize_text_field( $el );
        }

        return $new_arr;

    }

    public function megacal_ajax_get_event_upsert() {

        if( !DOING_AJAX ) die(); // only allow AJAX

        check_ajax_referer( '_megacal_get_event_upsert_nonce', '_nonce' );

        if( !empty( $_POST['eventId'] ) ) {

            if( !is_numeric( $_POST['eventId'] ) ) {
                wp_send_json_error( array( 'message' => 'Invalid event ID' ) );
            }
    
            $event_id = intval( $_POST['eventId'] );
    
            try {
    
                $response = MegaCalAPI::request( 
                    MegaCalAPI::EVENT_REQUEST, 
                    'get_event_upsert', 
                    array( 'event_id' => $event_id ) 
                );
    
            } catch( ApiException $e ) {
    
                wp_send_json_error( array( 'message' => $e->get_simple_message() ) );
    
            }
    
            if( !( $response instanceof EventUpsertBodyResponse ) ) {
                wp_send_json_error( array( 'message' => 'Something went wrong' ) );
            }
    
            $event = $response->get_event();

        } 
        
        ob_start();

            require( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-event-form.php' );
            $content = ob_get_contents();
        
        ob_end_clean();

        wp_send_json_success( array( 'content' => $content ) );

    }

    public function megacal_ajax_set_event_approval() {

        if( !DOING_AJAX ) die(); // only allow AJAX

        check_ajax_referer( '_megacal_set_event_approval_nonce', '_nonce' );

        $args = array();

        if( empty( $_POST['userId'] ) || !is_numeric( $_POST['userId'] ) ) {
            wp_send_json_error( array( 'message' => 'Invalid user ID' ) );
        }

        $args['user_id'] = intval( $_POST['userId'] );

        if( !empty( $_POST['eventId'] ) ) {
            if( !is_numeric( $_POST['eventId'] ) ) {
                wp_send_json_error( array( 'message' => 'Invalid event ID' ) );
            }

            $args['event_id'] = intval( $_POST['eventId'] );
        }

        $action_map = array( 
            'approve' => UserRequest::STATUS_YES, 
            'deny' => UserRequest::STATUS_NO, 
            'always' => UserRequest::STATUS_ALL, 
            'approve_pending' => UserRequest::STATUS_APPROVE_PENDING, 
            'deny_pending' => UserRequest::STATUS_DENY_PENDING, 
        );

        if( !key_exists( $_POST['approvalAction'], $action_map ) ) {
            wp_send_json_error( array( 'message' => 'Invalid approval status' ) );
        }

        $approval_action = $action_map[$_POST['approvalAction']];
        $args['approbation'] = $approval_action;
        
        try {

            $response = MegaCalAPI::request( MegaCalAPI::USER_REQUEST, 'put_approval', $args );

        } catch( ApiException $e ) {

            wp_send_json_error( array( 'message' => $e->get_simple_message() ) );

        }

        if( !( $response instanceof PutApprovalResponse ) ) {

            wp_send_json_error( array( 'message' => 'Something went wrong' ) );
        
        }

        $this->megacal_flush_event_cache();
        
        wp_send_json_success( array( 'response' => $response ) );

    }

    public function megacal_ajax_delete_event() {

        if( !DOING_AJAX ) die(); // only allow AJAX

        check_ajax_referer( '_megacal_delete_event_nonce', '_nonce' );

        if( empty( $_POST['eventId'] ) || !is_numeric( $_POST['eventId'] ) ) {
            wp_send_json_error( array( 'message' => 'Invalid event ID' ) );
        }

        $event_id = intval( $_POST['eventId'] );
        $event_change_type = sanitize_text_field( $_POST['eventChangeType'] );
        
        try {

            $response = MegaCalAPI::request( MegaCalAPI::EVENT_REQUEST, 'delete_event', array(
               'event_id' => $event_id,
               'change_type' => $event_change_type,
            ) );

        } catch( ApiException $e ) {

            wp_send_json_error( array( 'message' => $e->get_simple_message() ) );

        }

        if( !( $response instanceof EventDeleteResponse ) ) {

            wp_send_json_error( array( 'message' => 'Something went wrong' ) );
        
        }

        $this->megacal_flush_event_cache();
        
        wp_send_json_success( array( 'response' => $response ) );

    }

    public function megacal_ajax_fetch_admin_calendar_events() {

        if( !DOING_AJAX ) die(); // only allow AJAX

        check_ajax_referer( '_megacal_fetch_events_nonce', '_nonce' );

        if( !$this->megacal_is_valid_date( $_POST['startDate'] ) || !$this->megacal_is_valid_date( $_POST['endDate'] ) ) {
            wp_send_json_error( array( 'message' => 'Invalid start/end date format' ) );
        }

        $event_cat_ids = array();
        if( !empty( $_POST['eventCategories'] ) ) {

            // validate
            if( !is_array( $_POST['eventCategories'] ) ) {
                wp_send_json_error( array( 'message' => 'Invalid value for eventCategories' ) );
            }

            $event_categories = $_POST['eventCategories'];
            $cat_ids = array_map( function( $e ) { return $e->get_id(); }, $this->megacal_get_category_list() );
            foreach( $event_categories as $cat ) {

                if( intval( $cat ) != $cat ) {
                    wp_send_json_error( array( 'message' => 'Invalid event category' ) );
                }

                if( !in_array( $cat, $cat_ids ) ) {
                    wp_send_json_error( array( 'message' => 'Invalid event category' ) );

                }

                $event_cat_ids[] = intval( $cat );

            }

        }

        $start_date = date( 'Y-m-d', strtotime( $_POST['startDate'] ) );
        $end_date = date( 'Y-m-d', strtotime( $_POST['endDate'] ) );
 
        $event_owner = '';

        $events = $this->megacal_maybe_fetch_event_range( $start_date, $end_date, $event_owner, MEGACAL_ADMIN_CALENDAR_CACHE_KEY );

        if( !empty( $event_cat_ids ) ) {
            $events = $this->megacal_filter_events_by_categories( $events, $event_cat_ids );
        }

        if( $events instanceof WP_Error ) {
            wp_send_json_error( array( 'message' => $events->get_error_message() ) );
        }

        wp_send_json_success( array( 'events' => $events ) );

    }

    public function megacal_ajax_fetch_public_calendar_events() {

        if( !DOING_AJAX ) die(); // only allow AJAX

        check_ajax_referer( '_megacal_fetch_public_events_nonce', '_nonce' );

        if( !$this->megacal_is_valid_date( $_POST['startDate'] ) || !$this->megacal_is_valid_date( $_POST['endDate'] ) ) {
            wp_send_json_error( array( 'message' => 'Invalid start/end date format' ) );
        }

        $event_cat_ids = array();
        if( !empty( $_POST['eventCategories'] ) ) {

            // validate
            if( !is_array( $_POST['eventCategories'] ) ) {
                wp_send_json_error( array( 'message' => 'Invalid value for eventCategories' ) );
            }

            $event_categories = $_POST['eventCategories'];
            $cat_ids = array_map( function( $e ) { return $e->get_id(); }, $this->megacal_get_category_list() );
            foreach( $event_categories as $cat ) {

                if( intval( $cat ) != $cat ) {
                    wp_send_json_error( array( 'message' => 'Invalid event category' ) );
                }

                if( !in_array( $cat, $cat_ids ) ) {
                    wp_send_json_error( array( 'message' => 'Invalid event category' ) );

                }

                $event_cat_ids[] = intval( $cat );

            }

        }

        $start_date = date( 'Y-m-d', strtotime( $_POST['startDate'] ) );
        $end_date = date( 'Y-m-d', strtotime( $_POST['endDate'] ) );
        $event_owner = ( !empty( $_POST['eventOwner'] ) ) && intval( $_POST['eventOwner'] == $_POST['eventOwner']) ? intval( $_POST['eventOwner'] ) : '';
 
        $events = $this->megacal_maybe_fetch_event_range( $start_date, $end_date, $event_owner, MEGACAL_PUBLIC_CALENDAR_CACHE_KEY );

        if( !empty( $event_cat_ids ) ) {
            $events = $this->megacal_filter_events_by_categories( $events, $event_cat_ids );
        }

        if( $events instanceof WP_Error ) {
            wp_send_json_error( array( 'message' => $events->get_error_message() ) );
        }

        wp_send_json_success( array( 'events' => $events ) );

    }

    /**
     * Filter events by an array of category ids
     * 
     * TODO: Implement multi-category filter in API
     * 
     * @param array<Event> The events to filter
     * @param array<int> The array of category ids to filter on
     * 
     * @return array<Event> The filtered list of events
     */
    private function megacal_filter_events_by_categories( $events, $event_cat_ids ) {

        if( empty( $event_cat_ids ) || !is_array( $events ) ) 
            return $events;

        $filtered_events = array();

        foreach( $events as $event ) {
            
            $event_cat = $event['category'];
            $event_cat_id = intval( $event_cat['id'] );

            if( !in_array( $event_cat_id, $event_cat_ids ) ) {
                continue;
            }

            $filtered_events[] = $event;

        }

        return $filtered_events;

    }

    public function megacal_ajax_fetch_list_events() {

        if( !DOING_AJAX ) die(); // only allow AJAX

        check_ajax_referer( '_megacal_fetch_public_events_nonce', '_nonce' );

        $settings = self::megacal_get_settings();

        //Set and validate post vars
        $listType = (isset($_POST['listType']) && $_POST['listType'] && is_string($_POST['listType'])) ? sanitize_text_field( $_POST['listType'] ) : 'upcoming';
        $descrip = (isset($_POST['descrip']) && "true" == $_POST['descrip'] ) ? TRUE : FALSE;
        $buttons = (isset($_POST['buttons']) && $_POST['buttons'] && is_string($_POST['buttons'])) ? sanitize_text_field($_POST['buttons']) : 'left';
        $listStyle = ( !empty( $_POST['list_style'] ) && is_string( $_POST['list_style'] ) ) ? sanitize_text_field( $_POST['list_style'] ) : $settings['megacal_default_style'];
        $listDate = ( !empty( $_POST['list_date'] ) ) && $this->megacal_is_valid_date( $_POST['list_date'] ) ? date( 'Y-m-d', strtotime( $_POST['list_date'] ) ) : 'now';
        $event_owner = ( !empty( $_POST['eventOwner'] ) ) && intval( $_POST['eventOwner'] ) == $_POST['eventOwner'] ? intval( $_POST['eventOwner'] ) : '';
        $current_page = ( !empty( $_POST['currentPage'] ) && intval( $_POST['currentPage'] ) == $_POST['currentPage'] ) ? intval( $_POST['currentPage'] ) : 0;
        $month = !empty( $_POST['prevMonth'] ) ? sanitize_text_field( $_POST['prevMonth'] ) : '';

        // strip out any unicode chars that made it this far
        $listType = $this->megacal_strip_unicode( $listType );
        $descrip = $this->megacal_strip_unicode( $descrip );
        $buttons = $this->megacal_strip_unicode( $buttons );
        $listStyle = $this->megacal_strip_unicode( $listStyle );
        $event_owner = $this->megacal_strip_unicode( $event_owner );

        if( 'full' !== $listStyle && 'compact' !== $listStyle && 'simple' !== $listStyle ) {
            $listStyle = 'full';
        }
	
        $events = array();

        $args = array();

        if( !empty( $event_owner ) ) {
            $args['event_owner'] = $event_owner;
        }

        $args['max_result'] = MEGACAL_EVENT_LIST_RESULTS_PER_PAGE;
        $args['start_row'] = MEGACAL_EVENT_LIST_RESULTS_PER_PAGE * $current_page;

        if( 'past' === $listType ):
            $response = $this->megacal_get_past_events( $args );
        else: // assume upcoming if the value is wrong
            $response = $this->megacal_get_upcoming_events( $args );
        endif;
    
        if( $response instanceof WP_Error ) {
            wp_send_json_error( array( 'message' => $response->get_error_message() ) );
        }

        ob_start();

            require megacal_get_template_part( 'views/megacal', $listStyle . '-events-list', false );
            $content = ob_get_contents();

        ob_end_clean();

        wp_send_json_success( array( 
            'content' => $content,
        ) );

        wp_die();
    }

    /**
     * Gets upcoming events either from cache or from the API
     */
    private function megacal_get_upcoming_events( $args = array() ) {

        $cache = get_transient( MEGACAL_UPCOMING_LIST_CACHE_KEY );

        $args = wp_parse_args( $args, array(
            'upcoming' => true,
            'published' => true,
        ));

        $cache_sub_key = md5( serialize( $args ) );

        if( false === $cache || !array_key_exists( $cache_sub_key, $cache ) ) {

            $response = $this->megacal_get_event_request( $args );

            $cache = empty( $cache ) ? array() : $cache;
            $cache[$cache_sub_key] = $response;

            set_transient( 
                MEGACAL_UPCOMING_LIST_CACHE_KEY, 
                $cache, 
                MEGACAL_EVENT_CACHE_EXPIRE_TIME
            );

        } else {

            $response = $cache[$cache_sub_key];

        }

        return $response;

    }

    private function megacal_get_past_events( $args = array() ) {

        $cache = get_transient( MEGACAL_PAST_LIST_CACHE_KEY );

        $args = wp_parse_args( $args, array(
            'upcoming' => false,
            'published' => true,
        ));

        $cache_sub_key = md5( serialize( $args ) );

        if( false === $cache || !array_key_exists( $cache_sub_key, $cache ) ) {

            $response = $this->megacal_get_event_request( $args );

            $cache = empty( $cache ) ? array() : $cache;
            $cache[$cache_sub_key] = $response;

            set_transient( 
                MEGACAL_PAST_LIST_CACHE_KEY, 
                $cache, 
                MEGACAL_EVENT_CACHE_EXPIRE_TIME
            );

        } else {

            $response = $cache[$cache_sub_key];

        }

        return $response;

    }

    public function megacal_maybe_fetch_event_range( $start_date, $end_date, $event_owner, $cache_key ) {

        $cache_sub_key = empty( $event_owner ) ? $start_date . '_' . $end_date : $start_date . '_' . $end_date . '_' . $event_owner;

        // TODO: In memory cache on top to reduce DB calls
        $cache = get_transient( $cache_key );

        if( false === $cache || !array_key_exists( $cache_sub_key, $cache ) ) {

            $cache = empty( $cache ) ? array() : $cache;
            $calendar_keys = array( MEGACAL_ADMIN_CALENDAR_CACHE_KEY, MEGACAL_PUBLIC_CALENDAR_CACHE_KEY );
            $manage_keys = array( MEGACAL_ADMIN_CALENDAR_CACHE_KEY );

            $args = array(
                'start_date' => $start_date,
                'end_date' => $end_date,
            );

            if( in_array( $cache_key, $calendar_keys ) ) {
                $args['return'] = 'response';
            }

            if( !empty( $event_owner ) ) {
                $args['event_owner'] = $event_owner;
            }

            if( in_array( $cache_key, $manage_keys ) ) {

                $events = $this->megacal_get_events( $args );

            } else {

                $events = $this->megacal_get_public_events( $args );

            }
    
            if( $events instanceof WP_Error ) {
                return $events;
            }
    
            $cache[$cache_sub_key] = $events;

            set_transient( 
                $cache_key, 
                $cache,
                MEGACAL_EVENT_CACHE_EXPIRE_TIME
            );

        } else {

            $events = $cache[$cache_sub_key];
        
        }

        return $events;

    }

    /**
     * Formats an event's time for display to the front-end
     * 
     * @param Event $event The Event object
     * 
     * @return string A formatted string 
     */
    private function megacal_get_event_time_string( $event ) {

        if( empty( $event->get_start_time() ) && empty( $event->get_end_time() ) )
            return 'All Day';

        // Should never happen after the above check, so we won't try to handle it
        if( empty( $event->get_start_time() ) || empty( $event->get_end_time() ) )
            return '';

        $fmt = $this->megacal_get_time_fmt();
        $time = 'Time: ' . date( $fmt, strtotime( $event->get_start_time() ) ) . ' - ' . date( $fmt, strtotime( $event->get_end_time() ) );
        return $time;

    }

    public function megacal_ajax_load_event_popup() {

        if( !DOING_AJAX ) die();

        check_ajax_referer( '_megacal_get_event_popup_nonce', '_nonce' );

        if( empty( $_POST['eventId'] ) || !is_numeric( $_POST['eventId'] ) ) {
            wp_send_json_error( array( 'message' => 'Invalid event ID' ) );
        }

        $event_id = intval( $_POST['eventId'] );
        $hover_cards = get_transient( MEGACAL_CACHED_HOVER_CARD_CACHE_KEY ) ?: array();

        if( empty( $hover_cards[$event_id] ) ) {

            try {

                $event_detail_response = MegaCalAPI::request( MegaCalAPI::EVENT_REQUEST, 'get_event', array(
                    'event_id' => $event_id,
                ));
    
                if( !( $event_detail_response instanceof EventDetailResponse ) ) {
                    wp_send_json_error( array( 'message' => 'Unexpected API response' ) );
                }
    
                $event = $event_detail_response->get_event();
                $hover_cards[$event_id] = $event;
    
                set_transient(
                    MEGACAL_CACHED_HOVER_CARD_CACHE_KEY,
                    $hover_cards,
                    3 * HOUR_IN_SECONDS
                );
    
            } catch( ApiException $e ) {
    
                wp_send_json_error( array( 'message' => $e->get_simple_message() ) );
    
            }

        } else {
            
            $event = $hover_cards[$event_id];

        }

        ob_start();

            require_once megacal_get_template_part( 'includes/partials/part', 'popup-content', false );
            $content = ob_get_contents();
        
        ob_end_clean();

        wp_send_json_success( array( 'content' => $content ) );

    }

    public function megacal_load_shortcode_options() {

        check_ajax_referer( 'load-shortcode-modal-nonce', '_nonce' );

        set_query_var( 'is_modal', true );

        echo '<div id="megacal-events-settings" class="wrap">';
            $this->megacal_display_shortcode_options();
        echo '</div>';

        wp_die();

    }

    public function megacal_get_approval_list() {

        check_ajax_referer( 'megacal_get_approval_list_nonce', '_nonce' );

        ob_start();
            require( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-approval-list.php' );
            $content = ob_get_contents();
        ob_end_clean();

        wp_send_json_success( array( 'content' => $content ) );

    }

    private function megacal_display_shortcode_options() {

        $settings = self::megacal_get_settings();
        $connected = !empty( $settings['megacal_access_token'] );

        include( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/admin/admin-page-sc.php' );

    }

    private function megacal_get_event_owner_filters() {

        $event_owners = get_transient( MEGACAL_CACHED_EVENT_OWNERS_CACHE_KEY );

        if( false === $event_owners ) {

            $event_owners = $this->megacal_update_cached_event_owners();

        }

        return $event_owners;

    }

    private function megacal_update_cached_event_owners() {

        try {

            $response = MegaCalAPI::request( 
                MegaCalAPI::EVENT_REQUEST, 
                'get_event_filters', 
                array() 
            );

            if( !( $response instanceof EventFilterResponse ) ) {
            
                error_log( 'Response was not EventFilterResponse' );
                return array();
    
            }
    
            $event_owners = $response->get_event_owners();
    
            set_transient( MEGACAL_CACHED_EVENT_OWNERS_CACHE_KEY, $event_owners, MEGACAL_EVENT_CACHE_EXPIRE_TIME );
    
            return $event_owners;

        } catch( ApiException $e ) {

            error_log( $e->getMessage() );
            return array();

        }

    }

    /** Flush all event caches */
    private function megacal_flush_event_cache() {

        /**
         * megacal_event_cache_keys hook
         * 
         * Use this hook to make sure your custom cache keys are flushed when event updates occur
         * 
         * @param array $cache_keys A list of cache keys associated with different event lists
         * 
         */
        $event_cache_keys = apply_filters( 'megacal_flush_event_cache_keys', array( 
            MEGACAL_ADMIN_CALENDAR_CACHE_KEY,
            MEGACAL_PUBLIC_CALENDAR_CACHE_KEY,
            MEGACAL_PAST_LIST_CACHE_KEY,
            MEGACAL_UPCOMING_LIST_CACHE_KEY,
            MEGACAL_CACHED_EVENT_OWNERS_CACHE_KEY,
            MEGACAL_CACHED_HOVER_CARD_CACHE_KEY,
        ) );

        foreach( $event_cache_keys as $cache_key ) {
            delete_transient( $cache_key );
        }

    }

    /** Flush cached upsert vals */
    private function megacal_flush_upsert_cache() {

        /**
         * megacal_event_cache_keys hook
         * 
         * Use this hook to make sure your custom cache keys are flushed when event updates occur
         * 
         * @param array $cache_keys A list of cache keys associated with different event lists
         * 
         */
        $upsert_cache_keys = apply_filters( 'megacal_flush_upsert_cache_keys', array( 
            MEGACAL_CACHED_MY_CATEGORIES_CACHE_KEY,
            MEGACAL_CACHED_VENUES_CACHE_KEY,
            MEGACAL_CACHED_CATEGORIES_CACHE_KEY,
        ) );

        foreach( $upsert_cache_keys as $cache_key ) {
            delete_transient( $cache_key );
        }

    }

    public static function megacal_get_settings( $option = 'megacal_options' ) {

        $settings = wp_cache_get( $option, 'megabase-calendar', false, $found );

		if( false === $found ) {
			
            $settings = get_option( $option );
            
            if( false == $settings ) {
                $settings = array();
            }
            
			wp_cache_set( $option, $settings, 'megabase-calendar' );
        }
        
        return $settings;

    }

    private function megacal_get_venue_list() {

        $venues = get_transient( MEGACAL_CACHED_VENUES_CACHE_KEY );

        if( false === $venues ) {

            $vals = $this->megacal_update_cached_upsert_vals();
            $venues = !empty( $vals['venues'] ) ? $vals['venues'] : array();

        }

        return $venues;
        
    }

    public function megacal_get_category_list() {

        $categories = get_transient( MEGACAL_CACHED_CATEGORIES_CACHE_KEY );

        if( false === $categories ) {

            $vals = $this->megacal_update_cached_upsert_vals();
            $categories = !empty( $vals['categories'] ) ? $vals['categories'] : array();

        }

        return $categories;
        
    }

    public function megacal_get_my_category_list() {

        $my_categories = get_transient( MEGACAL_CACHED_MY_CATEGORIES_CACHE_KEY );

        if( false === $my_categories ) {

            $vals = $this->megacal_update_cached_upsert_vals();
            $my_categories = !empty( $vals['my_categories'] ) ? $vals['my_categories'] : array();

        }

        return $my_categories;
        
    }

    private function megacal_update_cached_upsert_vals() {

        try {

            $response = MegaCalAPI::request( 
                MegaCalAPI::EVENT_REQUEST, 
                'get_new_upsert', 
            );

            if( !( $response instanceof EventUpsertBodyResponse ) ) {
            
                error_log( 'Response was not EventUpsertBodyResponse' );
                return array();
    
            }

            $filter_response = MegaCalAPI::request(
                MegaCalAPI::EVENT_REQUEST,
                'get_event_filters',
                array()
            );

            if( !( $filter_response instanceof EventFilterResponse ) ) {

                error_log( 'Response was not EventFilterResponse' );
                return array();

            }
    
            $filter_cat_ids = array();
            foreach( $filter_response->get_event_categories() as $filter_cat ) {

                $all_cats[] = $filter_cat;

                if( false === $filter_cat->get_owner() ) {
                    continue;
                }

                $filter_cat_ids[] = $filter_cat->get_id();

            }
            
            $my_categories = array_filter( $filter_response->get_event_categories(), function( $e ) use ( $filter_cat_ids ) {
                return in_array( $e->get_id(), $filter_cat_ids );
            });

            $vals = array();
            $vals['venues'] = $response->get_venues();
            $vals['categories'] = $all_cats;
            $vals['my_categories'] = $my_categories;

            set_transient( MEGACAL_CACHED_VENUES_CACHE_KEY, $vals['venues'], 12 * HOUR_IN_SECONDS );
            set_transient( MEGACAL_CACHED_CATEGORIES_CACHE_KEY, $vals['categories'], 12 * HOUR_IN_SECONDS );
            set_transient( MEGACAL_CACHED_MY_CATEGORIES_CACHE_KEY, $vals['my_categories'], 12 * HOUR_IN_SECONDS );
    
            return $vals;

        } catch( ApiException $e ) {

            error_log( $e->getMessage() );
            return array();

        }

    }

    private function megacal_is_pro_account() {

        if( empty( self::$access_token ) ) {
            return false;
        } 

        $ping = $this->megacal_ping_user_account();
        
        if( false === $ping ){
            return false;
        }

        return true === $ping->get_pro_account();

    }

    /**
     * Pings the API for user details
     * 
     * @return PingResponse|bool The ping response or false on failure
     */
    private function megacal_ping_user_account() {

        $response = get_transient( MEGACAL_PING_RESPONSE_CACHE_KEY );

        if( false !== $response ) {
            return $response;
        }

        try {
        
            $response = MegaCalAPI::request( MegaCalAPI::PING_REQUEST, 'ping' );

            if( $response instanceof PingResponse ) {

                set_transient( MEGACAL_PING_RESPONSE_CACHE_KEY, $response, MEGACAL_EVENT_CACHE_EXPIRE_TIME );

                return $response;

            }
        
        } catch( ApiException $e ) {
            
            error_log( $e->getMessage() );

        }

        return false;

    }

    private function megacal_get_time_fmt( $type = 'php' ) {

        $settings = self::megacal_get_settings();

        if( $type === 'js' ) {
            
            $fmt = 'h:mma';

            if( !empty( $settings['megacal_time_fmt'] ) ) {
                $fmt = '24-hour' == $settings['megacal_time_fmt'] ? 'HH:mm' : $fmt; 
            }

        } else {

            $fmt = 'g:ia';

            if( !empty( $settings['megacal_time_fmt'] ) ) {
                $fmt = '24-hour' == $settings['megacal_time_fmt'] ? 'H:i' : $fmt; 
            }

        }

        return $fmt;

    }

    private function megacal_get_ids_from_string( $csv ) {

        if( empty( $csv ) )
            return array();

        $ids = array();
        $raw_ids = explode( ',', $csv );

        foreach( $raw_ids as $id ) {
            
            if( $id != intval( $id ) )
                continue;

            if( empty( trim( $id ) ) )
                continue;

            $ids[] = trim( intval( $id ) );

        }

        return $ids;

    }

    /**
     * Maps recurrence types to custom names - if no mapping falls back to capitalized 
     * 
     * @param string $type The type name 
     * @param string $fmt The desired format - frequency, singular, plural
     * @return string The mapped type name
     * 
     */
    private function megacal_get_recurrence_type_mapping( $type, $fmt = MEGACAL_RECURRENCE_TYPE_FREQ_FMT ) {

        $map = array(

            MEGACAL_RECURRENCE_TYPE_FREQ_FMT => array(

                EventRecurrenceDetail::TYPE_DAILY => 'Daily',
                EventRecurrenceDetail::TYPE_WEEKLY => 'Weekly',
                EventRecurrenceDetail::TYPE_MONTHLY => 'Monthly',
                EventRecurrenceDetail::TYPE_ANNUALLY => 'Yearly',
                EventRecurrenceDetail::TYPE_WEEKDAY => 'Every Weekday (Mon - Fri)',
                EventRecurrenceDetail::TYPE_CUSTOM => 'Custom',
            
            ),

            MEGACAL_RECURRENCE_TYPE_SINGULAR_FMT => array(
                EventRecurrenceDetail::TYPE_DAILY => 'Day',
                EventRecurrenceDetail::TYPE_WEEKLY => 'Week',
                EventRecurrenceDetail::TYPE_MONTHLY => 'Month',
                EventRecurrenceDetail::TYPE_ANNUALLY => 'Year',
            ),

            MEGACAL_RECURRENCE_TYPE_PLURAL_FMT => array(
                EventRecurrenceDetail::TYPE_DAILY => 'Days',
                EventRecurrenceDetail::TYPE_WEEKLY => 'Weeks',
                EventRecurrenceDetail::TYPE_MONTHLY => 'Months',
                EventRecurrenceDetail::TYPE_ANNUALLY => 'Years',
            ),

        );

        if( empty( $map[$fmt] ) )
            return ucfirst( strtolower( $type ) );
        
        if( empty( $map[$fmt][$type] ) )
            ucfirst( strtolower( $type ) );

        return $map[$fmt][$type];
        
    }

    /**
     * Formats a number with its ordinal suffix
     * 
     */
    private function megacal_fmt_num_ordinal( $number ) {

        $ends = array('th','st','nd','rd','th','th','th','th','th','th');
        
        if( ( ( $number % 100 ) >= 11 ) && ( ( $number % 100 ) <= 13 ) )
            return $number. 'th';
        else
            return $number. $ends[$number % 10];

    }

    /** Register the Shortcode **/
    public static function sc_megacal_events( $atts ) {

        self::$shortcode_instances += 1;
        $shortcode_instance_id = self::$shortcode_instances;

        $settings = self::megacal_get_settings();
        $connected = !empty( $settings['megacal_access_token'] ); 

        ob_start();

        //Include the shortcode output
        include megacal_get_template_part( 'views/megacal', 'events-sc-output', false );

        $content = ob_get_clean();

        return $content;

    }

    function megacal_action_links( $links ) {

        $settings = self::megacal_get_settings();

        $links[] = '<a href="'. esc_url( get_admin_url(null, 'admin.php?page=megacal-integration') ) .'">Settings</a>';

        if( !$this->megacal_is_pro_account() && !isset( $_GET['paid'] ) ) {
            $links[] = '<a href="'. esc_url( get_admin_url(null, 'admin.php?page=megacal-upgrade') ) .'">Upgrade to Pro</a>';
        }

       return $links;

    }

    function megacal_strip_unicode( $target_string ) {

        $chr_map = array(

           // Windows codepage 1252
           "\xC2\x82", // U+0082⇒U+201A single low-9 quotation mark
           "\xC2\x84", // U+0084⇒U+201E double low-9 quotation mark
           "\xC2\x8B", // U+008B⇒U+2039 single left-pointing angle quotation mark
           "\xC2\x91", // U+0091⇒U+2018 left single quotation mark
           "\xC2\x92", // U+0092⇒U+2019 right single quotation mark
           "\xC2\x93", // U+0093⇒U+201C left double quotation mark
           "\xC2\x94", // U+0094⇒U+201D right double quotation mark
           "\xC2\x9B", // U+009B⇒U+203A single right-pointing angle quotation mark

           // Regular Unicode 
           "\xC2\xAB"    , // U+00AB left-pointing double angle quotation mark
           "\xC2\xBB"    , // U+00BB right-pointing double angle quotation mark
           "\xE2\x80\x98", // U+2018 left single quotation mark
           "\xE2\x80\x99", // U+2019 right single quotation mark
           "\xE2\x80\x9A", // U+201A single low-9 quotation mark
           "\xE2\x80\x9B", // U+201B single high-reversed-9 quotation mark
           "\xE2\x80\x9C", // U+201C left double quotation mark
           "\xE2\x80\x9D", // U+201D right double quotation mark
           "\xE2\x80\x9E", // U+201E double low-9 quotation mark
           "\xE2\x80\x9F", // U+201F double high-reversed-9 quotation mark
           "\xE2\x80\xB9", // U+2039 single left-pointing angle quotation mark
           "\xE2\x80\xBA", // U+203A single right-pointing angle quotation mark
        );

        return str_replace( $chr_map, '', $target_string );

    }

    /**
     * Returns an escaped version of $content passed through wp_kses_post and wpautop. Intentionally ignores shortcodes
     * 
     * @param string $content The content to escape
     * @return string The escaped content
     */
    function megacal_esc_wysiwyg( $content ) {
        return wp_kses_post( wpautop( $content ) );
    }

    public static function get_access_token() {
        return self::$access_token;
    }

    public static function get_refresh_token() {
        return self::$refresh_token;
    }

    public static function maybe_update_access_token( $access_token ) {

        if( $access_token == self::$access_token || empty( $access_token ) ) {
            return;
        }

        $parts = explode( '.', $access_token );
        if( 3 !== count( $parts ) ) {
            error_log( 'maybe_update_access_token: invalid JWT' );
            return;
        }

        $settings = self::megacal_get_settings();

        self::$access_token = $access_token;
        $settings['megacal_access_token'] = $access_token;
        update_option( 'megacal_options', $settings );

    }

    public function megacal_get_public_events( $args ) {

        $args['published'] = true;
        $events = $this->megacal_get_events( $args );
        return $events;

    }

    public function megacal_register_cron_events() {

        if( !wp_next_scheduled( 'megacal_check_event_processing_cron' ) ) {
            wp_schedule_event( time(), 'every_two_minutes', 'megacal_check_event_processing_cron' );
        }

        if( !wp_next_scheduled( 'megacal_clear_debug_log_cron' ) ) {
            $now = new DateTime();
            $first_of_next_month = $now->modify('+1 month')->format( 'Y-m-01 H:i:s' );

            wp_schedule_event( strtotime( $first_of_next_month ), 'monthly', 'megacal_clear_debug_log_cron' );
        }

    }

    public function megacal_check_event_processing() {
        
        $execution_id_store_update = array();
        $errors = array();
        $execution_id_store = $this->megacal_get_settings( 'megacal_execution_id_store' );

        if( empty( $execution_id_store ) ) {
            return;
        }

        foreach( $execution_id_store as $execution_id => $details ) {

            try {

                $processing_response = MegaCalAPI::request( 
                    MegaCalAPI::EVENT_REQUEST, 
                    'get_event_processing', 
                    array( 'execution_id' => $execution_id ) 
                );

                if( !( $processing_response instanceof EventProcessingResponse ) ) {
                    throw new ApiException( sprintf( 'Unexpected response type: "%s"', get_class( $processing_response ) ) );
                }

                $event_processing_details = $processing_response->get_event_processing_details();
                $phase = $event_processing_details->get_phase();
                $stages = $event_processing_details->get_stages();

                if( EventProcessingDetail::PHASE_TYPE_COMPLETED === $phase ) {

                    $flushable_stages = array(
                        EventProcessingStage::STAGE_PROCESS_EVENT_RECURRENCE,
                        EventProcessingStage::STAGE_PROCESS_CHANGE_EVENT_RECURRENCE,
                    );
                    
                    foreach( $stages as $stage ) {
                        // Flush cache if recurrence
                        if( in_array( $stage->get_name(), $flushable_stages ) ) {
                            $this->megacal_flush_event_cache();
                            break;
                        }
                    }

                    continue;
                }

                // Give tasks a day grace period to complete
                if( $details['created'] <= ( time() - DAY_IN_SECONDS ) ) {

                    $failed_stage = false;
                    $message_id = '';
                    
                    foreach( $stages as $stage ) {
                        if( EventProcessingStage::PHASE_TYPE_FAILED === $stage->get_phase() ) {
                            $failed_stage = true;
                            $message_id = $stage->get_message_id();
                            break;
                        }
                    }
    
                    if( $failed_stage ) {
                        $err = sprintf( 
                            'An event processing error was encountered, please contact support and provide the following details. Message ID: %s Execution ID: %s',
                            $message_id,
                            $execution_id
                        );

                        $errors[] = $err;
                        error_log( $err );

                        continue;
                    }

                }

                // keep any who are not complete but not past the grace period
                $execution_id_store_update[$execution_id] = $details;

            } catch( ApiException $e ) {

                // We keep the execution ids and check later if there is an issue 
                error_log( $e->getMessage() );
                $execution_id_store_update[$execution_id] = $details;
                continue;

            }

        }

        // Check anything new that was not just processed
        $final_execution_id_store = array_diff_key( $this->megacal_get_settings( 'megacal_execution_id_store' ), $execution_id_store );
        $final_execution_id_store = array_merge( $final_execution_id_store, $execution_id_store_update );
        $processing_errors = array_merge( $this->megacal_get_settings( 'megacal_processing_errors' ), $errors );

        update_option( 'megacal_execution_id_store', $final_execution_id_store );
        update_option( 'megacal_processing_errors', $processing_errors );

    }

    public function megacal_clear_debug_log() {
        file_put_contents( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'debug.log', '' );
    }

    public function megacal_register_custom_schedules() {

        add_filter( 'cron_schedules', function( $schedules ) {

            $schedules['every_two_minutes'] = array(
                'interval' => 2 * MINUTE_IN_SECONDS,
                'display'  => 'Every Two Minutes',
            );
            
            $schedules['every_five_minutes'] = array(
                'interval' => 5 * MINUTE_IN_SECONDS,
                'display'  => 'Every Five Minutes',
            );
    
            $schedules['monthly'] = array(
                'interval' => MONTH_IN_SECONDS,
                'display'  => 'Monthly',
            );
    
            return $schedules;

        } );

    }

    /**
     * Expose the get_events() method
     * 
     * @param array $args The array of arguments to pass to get_events() - see EventRequest for options 
     * 
     * $args['return'] = 'response' - returns the raw response associative array
     * 
     * @return array|WP_Error The array of events or WP_Error on failure
     */
    public function megacal_get_events( $args = array() ) {

        $return = '';

        if( !empty( $args['return'] ) ) {
            $return = $args['return'];
            unset( $args['return'] );
        }

        $response = $this->megacal_get_event_request( $args );

        if( $response instanceof WP_Error ) {
            return $response;
        }

        $body = $response->get_response_body();
        $results = $return == 'response' && !empty( $body['events'] ) ? $body['events'] : $response->get_events();

        /**
         * megacal_get_events_result
         * 
         * Filters the resulting array from megacal_get_events
         * @param array<Event> $events
         * 
         */
        return apply_filters( 'megacal_get_events_result', $results ); 

    }

    public function megacal_get_event_request( $args = array() ) {
        
        try {
            
            $response = MegaCalAPI::request( MegaCalAPI::EVENT_REQUEST, 'get_events', $args );

            if( !( $response instanceof EventListResponse ) ) {
                throw new ApiException( 'Unexpected response object' );
            }

            return $response;

        } catch( Exception $e ) {

            error_log( $e->getMessage() );
            return new WP_Error( $e->getCode(), $e->getMessage() );

        }
    
    }

    /**
     * Return the Stripe customer portal url - Can be overridden in .env for dev purposes
     */
    private function get_stripe_portal_url() {
        return !empty( $_ENV['MEGACAL_STRIPE_PORTAL_URL'] ) ? $_ENV['MEGACAL_STRIPE_PORTAL_URL'] : MEGACAL_STRIPE_PORTAL_URL;
    }

    public static function store_execution_id( $execution_id ) {

        $execution_id_store = self::megacal_get_settings( 'megacal_execution_id_store' );
        $execution_id_store[$execution_id] = array( 'created' => time() );
        update_option( 'megacal_execution_id_store', $execution_id_store );

    }

    public static function get_instance() {
        if(!empty(self::$instance)) {
            return self::$instance;
        } else {
            return new self();
        }
    }

}

// Instantiate the Plugin
$MegabaseCalendar = MegabaseCalendar::get_instance();

// Instantiate the API Accessor
$MegaCalAPI = MegaCalAPI::get_instance();

//Register the shortcode
add_shortcode( 'megacal', array( $MegabaseCalendar, 'sc_megacal_events' ) );

if (!function_exists('megacal_events')) {
    
    /**
     * Function for use in theme files
     * @param array args The arguments for the MegaCal Instance
     **/
    function megacal_events( $args = array() ) {

        $args = wp_parse_args( $args, get_default_megacal_args() );
        echo MegabaseCalendar::sc_megacal_events( $args );
    
    }

}

/**
 *  Gets default args for shortcode/template include
 **/
if( !function_exists( 'get_default_megacal_args' ) ) {

    function get_default_megacal_args() {

        $settings = MegabaseCalendar::megacal_get_settings();

        return array(
            'type' => '',
            'style' => $settings['megacal_default_style'],
            'display' => 'text',
            'theme' => 'light',
            'descrip' => FALSE,
            'view' => 'list',
            'buttons' => 'left',
            'showfilters' => FALSE,
            'hideview' => FALSE,
        );

    }

}

//Template loader functions - Allows overriding by theme
if (!function_exists('megacal_get_template_part')) {
    function megacal_get_template_part($slug, $name = null, $load = true) {
        // Execute code for this part
        do_action('get_template_part_' . $slug, $slug, $name);

        // Setup possible parts
        $templates = array();

        if (isset($name))
            $templates[] = $slug . '-' . $name . '.php';
        else
            $templates[] = $slug . '.php';

        // Allow template parts to be filtered
        $templates = apply_filters('megacal_get_template_part', $templates, $slug, $name);

        // Return the part that is found

        return megacal_locate_template($templates, $load, false);
    }
}

if (!function_exists('megacal_locate_template')) {

    function megacal_locate_template($template_names, $load = false, $require_once = true) {

        // No file found yet
        $located = false;

        // Try to find a template file
        foreach ((array)$template_names as $template_name) {

            // Continue if template is empty
            if (empty($template_name))
                continue;

            // Trim off any slashes from the template name
            $template_name = ltrim($template_name, '/');

            // Check child theme first
            if (file_exists(trailingslashit(get_stylesheet_directory()) . 'megabase-calendar/' . $template_name)) {
                $located = trailingslashit(get_stylesheet_directory()) . 'megabase-calendar/' . $template_name;
                break;

                // Check parent theme next
            } elseif (file_exists(trailingslashit(get_template_directory()) . 'megabase-calendar/' . $template_name)) {
                $located = trailingslashit(get_template_directory()) . 'megabase-calendar/' . $template_name;
                break;

                // Check plugin last
            } elseif (file_exists(trailingslashit(MEGACAL_PLUGIN_DIR) . $template_name)) {
                $located = trailingslashit(MEGACAL_PLUGIN_DIR) . $template_name;
                break;
            }
        }

        if ((true == $load) && !empty($located))
            load_template($located, $require_once);

        return $located;
    }

}

if( !function_exists( 'megacal_get_default_event_image_path' ) ) {
    function megacal_get_default_event_image_path() {
        return apply_filters( 'megacal_default_event_image_path', plugins_url( '/assets/img/default-event.jpg', MEGACAL_PLUGIN ) );
    }
}

if( !function_exists( 'megacal_is_event_detail' ) ) {
    function megacal_is_event_detail() {
        return boolval( get_query_var( 'event_detail' ) );
    }
}

endif; //if(!class_exists)