<?php
if( !defined( 'ABSPATH' ) ) die();
if( !current_user_can( MEGACAL_PLUGIN_VISIBILITY_CAP ) ) wp_die( 'Not Allowed' );

// check if the user submitted the settings
// wordpress will add the "settings-updated" $_GET parameter to the url
if( isset( $_GET['settings-updated'] ) ) {
	// add settings saved message with the class of "updated"
	add_settings_error( 'megacal_options', 'megacal_message_updated', 'Settings Saved', 'success' );
}

$settings = self::megacal_get_settings();

if( isset( $_GET['paid'] ) && boolval( $_GET['paid'] ) ) {
	delete_transient( MEGACAL_PING_RESPONSE_CACHE_KEY );
	add_settings_error( 'megacal_options', 'megacal_account_paid', 'Success: Payment received, thank you!', 'success' );
}

if( empty( $settings['megacal_access_token'] ) ) {
	add_settings_error( 'megacal_options', 'megacal_warning_megacal_access_token', 'MegaCal: Please Register or Connect your account', 'warning' );
}

// show error/update messages
settings_errors( 'megacal_options' );
?>

<div id="megacal-events-settings" class="wrap megacal-settings-page">

	<h1>MegaCalendar</h1>

	<?php include( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-notice-container.php' ); ?>
	
	<ul class="megacal-admin-tabs tabs">
		
		<?php if( current_user_can( MEGACAL_TOKEN_VISIBILITY_CAP ) ): ?>
			<?php if( empty( $settings['megacal_access_token'] ) ): ?>
				<li class="current">
					<a href="#megacal-events-settings-register">Register</a>
				</li>
			<?php endif; ?>

			<li class="<?php echo empty( $settings['megacal_access_token'] ) ? '' : 'current'; ?>">
				<a href="#megacal-events-settings-general">General</a>
			</li>
		<?php endif; ?>

		<li>
			<a href="#megacal-events-settings-sc">Shortcodes</a>
		</li>

		<!-- <li>
            <a href="#megacal-events-settings-sc">FAQs and Support</a>
        </li> -->

	</ul>

	<?php if( current_user_can( MEGACAL_TOKEN_VISIBILITY_CAP ) ): ?>
		<?php if( empty( $settings['megacal_access_token'] ) ): ?>
			<div id="megacal-events-settings-register" class="admin-tab">
				<h3>Register</h3>
				<p>If you do not have a MegaCalendar account, please register. <br />
				If you already have an account, enter your access and refresh tokens fields on the <b>General</b> tab.</p>
				<?php require_once( trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-register-form.php' ); ?>
			</div>
		<?php endif; ?>

		<div id="megacal-events-settings-general" class="admin-tab">
			
			<form action="options.php" method="post">
				<?php
				// output security fields for the registered setting
				settings_fields(MEGACAL_SETTINGS_SLUG);
				
				// output setting sections and their fields
				do_settings_sections(MEGACAL_SETTINGS_SLUG);
				
				// output save settings button
				submit_button('Save Settings');
				?>
			</form>

			<?php if( !empty( $settings['megacal_access_token'] ) ): ?>
				<h2>Advanced</h2>

				<p class="small">Use this if you need to copy or change your access/refresh tokens. <b>DO NOT SHARE THESE KEYS</b></p>
				<button id="megacal-show-tokens" class="button button-secondary">Show Access Tokens</button>
			<?php endif; ?>
		
		</div>
	<?php endif; ?>

	<?php $this->megacal_display_shortcode_options(); ?>

	<!--
		TODO: Uncomment when we have a repo page
	<p>
		<a href="https://wordpress.org/plugins/megabase-calendar/" target="_blank">WordPress.org Plugin Repository</a> 
		&nbsp;|&nbsp; 
		<a href="https://wordpress.org/support/plugin/megabase-calendar/reviews/" target="_blank">Leave a Review</a> 
	</p>
	-->

	<?php if( !empty( $settings['megacal_access_token'] ) ): ?>
		<div class="postbox megacal-account-details">
			<h3>Account Details</h3>
			<p>Account Type: <b><?php echo $this->megacal_is_pro_account() ? 'Pro' : 'Free'; ?></b></p>

			<?php if( $this->megacal_is_pro_account() ): ?>
				<a href="<?php echo $this->get_stripe_portal_url(); ?>" class="button button-secondary" target="_blank">Manage Subscription</a>
			<?php else: ?>
				<a href="<?php echo MEGACAL_UPGRADE_URL; ?>" class="button button-secondary">Upgrade to Pro</a>
			<?php endif; ?>
		</div>
	<?php endif; ?>
	
</div><!-- /.wrap -->