<?php 
/** Templating: Copy this file to mytheme/megabase-calendar/includes/partials/part-popup-content.php to override it. */

	if( !defined( 'ABSPATH' ) ) 
		die( 'Not Allowed' );
?>
<?php /*  mega-tooltip */ ?>
<div class="megacal-event-popup-inner cardFloater">

	<div class="thumbTile">
	
		<div class="eventFrame">
			<?php $event_img = $event->get_image_url(); ?>

			<?php if(!empty( $event_img )): ?>
				
				<div class="frameImagePic">
					<img src="<?php echo ( esc_url( $event->get_image_url() )) ?>" alt="<?php esc_html_e( $event->get_title() ); ?> Graphic" class="cardEventImage" />	
				</div>

			<?php else:  ?>							

				<div class="frameImagePic frameDefaultPic">
					<img src="<?php echo megacal_get_default_event_image_path(); ?>" alt="<?php esc_html_e( $event->get_title() ); ?> Graphic not available" class="cardEventImage cardDefaultPic" />
				</div>

			<?php endif; ?>		

			<div class="tileData">

				<h3><?php esc_html_e( $event->get_title() ); ?></h3>
				
				<div class="megacal-event-details">			

					<div class="megaMeta">

						<?php 
						/* Time */
						if( 
							!empty( $event->get_start_time() ) 
							|| !empty( $event->get_end_time() ) 
						): ?>
							<p class="eventTimep">
						<?php endif; ?>

						<?php $fmt = $this->megacal_get_time_fmt(); ?>
							<?php if( !empty( $event->get_start_time() ) ): ?>
								<i class="fas fa-clock"></i><span class="eventTime"><?php esc_html_e( date( $fmt, strtotime( $event->get_start_time() ) ) ); ?> </span>
							<?php endif; ?>
							
							<?php if( !empty( $event->get_end_time() ) ): ?>
								<span class="eventTime">- <?php esc_html_e( date( $fmt, strtotime( $event->get_end_time() ) ) ); ?></span>
							<?php endif; ?>

						<?php if( 
							!empty( $event->get_start_time() ) 
							|| !empty( $event->get_end_time() ) 
						): ?>
							</p>
						<?php endif; ?>

						
						<?php
						/* Venue */
						if( !empty( $event->get_venue() ) ): ?>
							<?php
							$venue = $event->get_venue(); 		
							?>
							<p class="venueTitle">
								<i class="fas fa-map-marker-alt"></i><?php esc_html_e($venue->get_name()); ?>

								<?php if( !empty( $venue->get_location() ) ): ?>
									- 
									<?php esc_html_e($venue->get_location()); ?>
								<?php endif; ?>
							</p>
						<?php endif; ?>					
						

						<?php 
						/* Description */
						if( !empty( $event->get_description() ) ): ?>
							<p class="eventTimep">
								<?php 
								$content = $event->get_description();
								echo strip_tags( $content );
								?>							
							</p>
						<?php endif; ?>

						
					</div>			
					
				</div>

			</div>

		</div>
	
		
	
	</div>

</div>