<?php
/** Templating: Copy this file to mytheme/megabase-calendar/views/megacal-compact-events-list.php to override it. */

	if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

	$settings = self::megacal_get_settings();

	if( empty( $response ) ) {
		return;
	}

	$events = $response->get_events();
?>

		<?php if( !empty($events) ): ?>

			<?php foreach($events as $event): ?>

				<?php

					$date = new DateTimeImmutable( $event->get_event_date() );
					include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-month-label.php';
				
					if( !empty( $event->get_event_date() ) ):

						$event_date = $event->get_event_date();
						$venue = $event->get_venue();
				?>

						<li id="event-<?php esc_attr_e( $event->get_id() ); ?>" class="rowView">
			
							<div class="rowColumn dateColumn">
								<h3 class="simpleTitle">
									<span><?php echo date('D', strtotime( $event_date )); ?></span>
									<span><?php echo date('M', strtotime( $event_date )); ?></span>
									<span><?php echo date('d', strtotime( $event_date )); ?></span>
									<span class="yearNum"><?php echo date('Y', strtotime( $event_date )); ?></span>
								</h3>         		
							</div>

							<div class="rowColumn venueColumn">
								<h3 class="simpleTitle">
									<a href="<?php echo site_url( trailingslashit( $settings['megacal_events_url'] ) . esc_attr( $event->get_id() ) ); ?>">
										<?php esc_html_e( $event->get_title() ); ?> at <?php esc_html_e( $venue->get_name() ); ?>
									</a>
								</h3>
							</div>
								
							<div class="rowColumn detailsColumn">
								<?php $venue_address = $venue->get_location(); ?>
								<?php if( !empty( $venue_address ) ): ?>
									<p>
										<?php esc_html_e( $venue_address ); ?>
									</p>
								<?php endif; ?>
									
								<p>
									<?php esc_html_e( $this->megacal_get_event_time_string( $event ) ); ?> 
									
									<?php if( !empty( $event->get_price_details() ) ): ?>
										<br /><?php esc_html_e( $event->get_price_details() ); ?>
									<?php endif; ?>
								</p>
							</div>
							
							<div class="rowColumn categoryColumn">
								<?php if( $event->get_event_category()->get_name() !== MEGACAL_DEFAULT_CATEGORY_NAME ): ?>
									<p class="event-category event-category-<?php esc_attr_e( $event->get_event_category()->get_id() ); ?>"><?php esc_html_e( $event->get_event_category()->get_name() ); ?></p>
								<?php endif; ?>
							</div>

							<div class="rowColumn buttonsColumn">

								<a href="<?php echo site_url( trailingslashit( $settings['megacal_events_url'] ) . esc_attr( $event->get_id() ) ); ?>" 
									class="simpleBtn showDetailsLink"
									title="View Details" 
				                    >View Event</a>

								<?php if( !empty( $event->get_ticket_url() ) ): ?>

				                 	<a href="<?php echo esc_url( $event->get_ticket_url(), array( 'http', 'https' ) ); ?>" class="simpleBtn" target="_blank" title="More information at <?php echo esc_url( $event->get_ticket_url(), array( 'http', 'https' ) ); ?>">
										<?php esc_html_e( $settings['megacal_event_url_label'] ); ?>
									</a>
				                 	
				             	<?php endif; ?>
				             	
				             	<?php if( !empty( $event->get_facebook_url() ) ): ?>        
									
									<a href="<?php echo esc_url( $event->get_facebook_url(), array( 'http', 'https' ) ); ?>" class="simpleBtn btn fbLinkWide" title="RSVP on Facebook" target="_blank"><i class="fui-facebook"></i>RSVP</a>
								
								<?php endif; ?>

							</div>

						</li>

						<?php 

					endif; 
				?>

			<?php endforeach; ?>
			
			<?php include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-list-total-pages.php'; ?>

		<?php else: ?>

			<?php
				if( !empty( $start_date ) )  {
					$date = new DateTimeImmutable( $start_date );
					include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-month-label.php';
				}
			?>

			<li id="event-none" class="summaryContent listEvent listItem cf">
				<p><?php echo esc_attr($settings['megacal_no_event_msg']); ?></p>
			</li>
		<?php endif; ?>

<?php
