<?php
/** Templating: Copy this file to mytheme/megabase-calendar/views/megacal-simple-events-list.php to override it. */

	if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directlya

	if( empty( $response ) ) {
		return;
	}

	$events = $response->get_events();
?>

<?php if( !empty( $events ) && !( $events instanceof WP_Error ) ): ?>	
	
	<div class="customList megaSimpleList megaEvents">
	
		<?php
			$settings = MegabaseCalendar::megacal_get_settings();
			$event_detail_path = $settings['megacal_events_url'];
		?>
	
		<?php foreach( $events as $event ): ?>
	
			<?php 
				$date = new DateTimeImmutable( $event->get_event_date() );
				include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-month-label.php';
			?>
	
			<div class="megaSimpleEvent">

				<div class="leftDate" style="background:url('<?php esc_html_e( $event->get_image_url() ); ?>') no-repeat center center; background-size:cover;">

					<div class="megaDateRegion dateMask">

						<h3 class="megaDate" title="<?php echo date('D M d, Y', strtotime( $event->get_event_date() )); ?>">
							<span class="monthName dayNameAbb">
								<?php esc_html_e( date( 'D', strtotime( $event->get_event_date() ) )) ; ?>
							</span>

							<span class="monthName">
								<?php esc_html_e( date( 'M', strtotime( $event->get_event_date() ))); ?>
							</span>

							<span class="dayNum">
								<?php esc_html_e(  date( 'd', strtotime( $event->get_event_date() ))); ?>
							</span>

							<span class="yearNum">
								<?php esc_html_e( date( 'Y', strtotime( $event->get_event_date() ))); ?>
							</span>
						</h3>

					</div>		

				</div>						

				<div class="rightEventContent">
	
					<div class="megaDetails">
						<div class="megaEventTitle">
							<h3><?php esc_html_e( $event->get_title() ); ?></h3>
						</div>

						<div class="megaMeta">
	
							<?php 
							/* Time */
							if( 
								!empty( $event->get_start_time() ) 
								|| !empty( $event->get_end_time() ) 
							): ?>
								<p class="eventTimep">
							<?php endif; ?>
								
							<?php $fmt = $this->megacal_get_time_fmt(); ?>
	
								<?php if( !empty( $event->get_start_time() ) ): ?>
									<?php esc_html_e( date( $fmt, strtotime( $event->get_start_time() ) ) ); ?> 
								<?php endif; ?>
								
								<?php if( !empty( $event->get_end_time() ) ): ?>
									- <?php esc_html_e( date( $fmt, strtotime( $event->get_end_time() ) ) ); ?>
								<?php endif; ?>
	
							<?php if( 
								!empty( $event->get_start_time() ) 
								|| !empty( $event->get_end_time() ) 
							): ?>
								</p>
							<?php endif; ?>
	
							<?php if( !empty( $event->get_venue() ) ): ?>
								<?php $venue = $event->get_venue(); ?>

								<p class="venueTitle">
									<?php esc_html_e($venue->get_name()); ?>
								</p>

								<p class="venueLocation">
									<?php esc_html_e($venue->get_location()); ?>
								</p>								
							<?php endif; ?>

							<?php if( $event->get_event_category()->get_name() !== MEGACAL_DEFAULT_CATEGORY_NAME ): ?>
								<p class="event-category event-category-<?php esc_attr_e( $event->get_event_category()->get_id() ); ?>"><?php esc_html_e( $event->get_event_category()->get_name() ); ?></p>
							<?php endif; ?>

						</div>

						<div class="megaEventLinks">
							<a href="<?php echo site_url( trailingslashit( $event_detail_path ) . $event->get_id() ); ?>" class="megaEventButton megaDetailLink" title="View webpage for this event">Details &raquo;</a>

							<?php if( !empty( $event->get_ticket_url() ) ): ?>
								<a href="<?php esc_html_e( $event->get_ticket_url() ); ?>" class="megaEventButton megaExternalLink" title="Print URL" target="_blank">	Visit &#8599;</a>
							<?php endif; ?>
						</div>

					</div>
				</div>										
			</div>
	
		<?php endforeach; ?>

		<?php include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-list-total-pages.php'; ?>
	
	</div>

<?php else: ?>

	<?php
		if( !empty( $start_date ) )  {
			$date = new DateTimeImmutable( $start_date );
			include trailingslashit( MEGACAL_PLUGIN_DIR ) . 'includes/partials/part-month-label.php';
		}
	?>

	<li id="event-none" class="summaryContent listEvent listItem cf">
		<p><?php echo esc_html( $settings['megacal_no_event_msg'] ); ?></p>

		<?php if( $events instanceof WP_Error && is_user_logged_in() ): ?>
			<p><?php echo esc_html( $events->get_error_message() ); ?></p>	
		<?php endif; ?>
	</li>
<?php endif; ?>

<?php
